/* SPDX-License-Identifier: BSD-3-Clause
 * Copyright(c) 2014-2021 Broadcom
 * All rights reserved.
 */

/* date: Wed Mar 17 11:31:19 2021 */

#include "ulp_template_db_enum.h"
#include "ulp_template_db_field.h"
#include "ulp_template_struct.h"
#include "ulp_template_db_tbl.h"

/* Define the template structures */
/*
 * Classification signature table:
 * maps hash id to ulp_class_match_list[] index
 */
uint16_t ulp_class_sig_tbl[BNXT_ULP_CLASS_SIG_TBL_MAX_SZ] = {
	[BNXT_ULP_CLASS_HID_55dd] = 1,
	[BNXT_ULP_CLASS_HID_1df1] = 2,
	[BNXT_ULP_CLASS_HID_3e55] = 3,
	[BNXT_ULP_CLASS_HID_0649] = 4,
	[BNXT_ULP_CLASS_HID_1011] = 5,
	[BNXT_ULP_CLASS_HID_40e9] = 6,
	[BNXT_ULP_CLASS_HID_3e99] = 7,
	[BNXT_ULP_CLASS_HID_06ad] = 8,
	[BNXT_ULP_CLASS_HID_38c7] = 9,
	[BNXT_ULP_CLASS_HID_00fb] = 10,
	[BNXT_ULP_CLASS_HID_24d3] = 11,
	[BNXT_ULP_CLASS_HID_559b] = 12,
	[BNXT_ULP_CLASS_HID_5003] = 13,
	[BNXT_ULP_CLASS_HID_1837] = 14,
	[BNXT_ULP_CLASS_HID_3bef] = 15,
	[BNXT_ULP_CLASS_HID_0403] = 16,
	[BNXT_ULP_CLASS_HID_3d3f] = 17,
	[BNXT_ULP_CLASS_HID_0543] = 18,
	[BNXT_ULP_CLASS_HID_292b] = 19,
	[BNXT_ULP_CLASS_HID_59e3] = 20,
	[BNXT_ULP_CLASS_HID_5d3b] = 21,
	[BNXT_ULP_CLASS_HID_254f] = 22,
	[BNXT_ULP_CLASS_HID_4917] = 23,
	[BNXT_ULP_CLASS_HID_113b] = 24,
	[BNXT_ULP_CLASS_HID_55fd] = 25,
	[BNXT_ULP_CLASS_HID_1dd1] = 26,
	[BNXT_ULP_CLASS_HID_3e75] = 27,
	[BNXT_ULP_CLASS_HID_0669] = 28,
	[BNXT_ULP_CLASS_HID_1ba1] = 29,
	[BNXT_ULP_CLASS_HID_4c69] = 30,
	[BNXT_ULP_CLASS_HID_0439] = 31,
	[BNXT_ULP_CLASS_HID_34e1] = 32,
	[BNXT_ULP_CLASS_HID_0465] = 33,
	[BNXT_ULP_CLASS_HID_352d] = 34,
	[BNXT_ULP_CLASS_HID_55b1] = 35,
	[BNXT_ULP_CLASS_HID_1da5] = 36,
	[BNXT_ULP_CLASS_HID_32fd] = 37,
	[BNXT_ULP_CLASS_HID_63a5] = 38,
	[BNXT_ULP_CLASS_HID_1b75] = 39,
	[BNXT_ULP_CLASS_HID_4c3d] = 40,
	[BNXT_ULP_CLASS_HID_1031] = 41,
	[BNXT_ULP_CLASS_HID_40c9] = 42,
	[BNXT_ULP_CLASS_HID_3eb9] = 43,
	[BNXT_ULP_CLASS_HID_068d] = 44,
	[BNXT_ULP_CLASS_HID_5039] = 45,
	[BNXT_ULP_CLASS_HID_180d] = 46,
	[BNXT_ULP_CLASS_HID_15fd] = 47,
	[BNXT_ULP_CLASS_HID_46b5] = 48,
	[BNXT_ULP_CLASS_HID_303d] = 49,
	[BNXT_ULP_CLASS_HID_60f5] = 50,
	[BNXT_ULP_CLASS_HID_5ea5] = 51,
	[BNXT_ULP_CLASS_HID_2689] = 52,
	[BNXT_ULP_CLASS_HID_0771] = 53,
	[BNXT_ULP_CLASS_HID_3809] = 54,
	[BNXT_ULP_CLASS_HID_35f9] = 55,
	[BNXT_ULP_CLASS_HID_66b1] = 56,
	[BNXT_ULP_CLASS_HID_559d] = 57,
	[BNXT_ULP_CLASS_HID_1db1] = 58,
	[BNXT_ULP_CLASS_HID_3e15] = 59,
	[BNXT_ULP_CLASS_HID_0609] = 60,
	[BNXT_ULP_CLASS_HID_1bc1] = 61,
	[BNXT_ULP_CLASS_HID_4c09] = 62,
	[BNXT_ULP_CLASS_HID_0459] = 63,
	[BNXT_ULP_CLASS_HID_3481] = 64,
	[BNXT_ULP_CLASS_HID_0405] = 65,
	[BNXT_ULP_CLASS_HID_354d] = 66,
	[BNXT_ULP_CLASS_HID_55d1] = 67,
	[BNXT_ULP_CLASS_HID_1dc5] = 68,
	[BNXT_ULP_CLASS_HID_329d] = 69,
	[BNXT_ULP_CLASS_HID_63c5] = 70,
	[BNXT_ULP_CLASS_HID_1b15] = 71,
	[BNXT_ULP_CLASS_HID_4c5d] = 72,
	[BNXT_ULP_CLASS_HID_1051] = 73,
	[BNXT_ULP_CLASS_HID_40a9] = 74,
	[BNXT_ULP_CLASS_HID_3ed9] = 75,
	[BNXT_ULP_CLASS_HID_06ed] = 76,
	[BNXT_ULP_CLASS_HID_5059] = 77,
	[BNXT_ULP_CLASS_HID_186d] = 78,
	[BNXT_ULP_CLASS_HID_159d] = 79,
	[BNXT_ULP_CLASS_HID_46d5] = 80,
	[BNXT_ULP_CLASS_HID_305d] = 81,
	[BNXT_ULP_CLASS_HID_6095] = 82,
	[BNXT_ULP_CLASS_HID_5ec5] = 83,
	[BNXT_ULP_CLASS_HID_26e9] = 84,
	[BNXT_ULP_CLASS_HID_0711] = 85,
	[BNXT_ULP_CLASS_HID_3869] = 86,
	[BNXT_ULP_CLASS_HID_3599] = 87,
	[BNXT_ULP_CLASS_HID_66d1] = 88,
	[BNXT_ULP_CLASS_HID_38e7] = 89,
	[BNXT_ULP_CLASS_HID_00db] = 90,
	[BNXT_ULP_CLASS_HID_24f3] = 91,
	[BNXT_ULP_CLASS_HID_55bb] = 92,
	[BNXT_ULP_CLASS_HID_5023] = 93,
	[BNXT_ULP_CLASS_HID_1817] = 94,
	[BNXT_ULP_CLASS_HID_3bcf] = 95,
	[BNXT_ULP_CLASS_HID_0423] = 96,
	[BNXT_ULP_CLASS_HID_58e3] = 97,
	[BNXT_ULP_CLASS_HID_20d7] = 98,
	[BNXT_ULP_CLASS_HID_448f] = 99,
	[BNXT_ULP_CLASS_HID_0ce3] = 100,
	[BNXT_ULP_CLASS_HID_076b] = 101,
	[BNXT_ULP_CLASS_HID_3813] = 102,
	[BNXT_ULP_CLASS_HID_5bcb] = 103,
	[BNXT_ULP_CLASS_HID_243f] = 104,
	[BNXT_ULP_CLASS_HID_144b] = 105,
	[BNXT_ULP_CLASS_HID_4573] = 106,
	[BNXT_ULP_CLASS_HID_0057] = 107,
	[BNXT_ULP_CLASS_HID_311f] = 108,
	[BNXT_ULP_CLASS_HID_2b87] = 109,
	[BNXT_ULP_CLASS_HID_5c4f] = 110,
	[BNXT_ULP_CLASS_HID_1793] = 111,
	[BNXT_ULP_CLASS_HID_485b] = 112,
	[BNXT_ULP_CLASS_HID_3447] = 113,
	[BNXT_ULP_CLASS_HID_650f] = 114,
	[BNXT_ULP_CLASS_HID_2053] = 115,
	[BNXT_ULP_CLASS_HID_511b] = 116,
	[BNXT_ULP_CLASS_HID_4b83] = 117,
	[BNXT_ULP_CLASS_HID_13f7] = 118,
	[BNXT_ULP_CLASS_HID_37af] = 119,
	[BNXT_ULP_CLASS_HID_6857] = 120,
	[BNXT_ULP_CLASS_HID_3d1f] = 121,
	[BNXT_ULP_CLASS_HID_0563] = 122,
	[BNXT_ULP_CLASS_HID_290b] = 123,
	[BNXT_ULP_CLASS_HID_59c3] = 124,
	[BNXT_ULP_CLASS_HID_5d1b] = 125,
	[BNXT_ULP_CLASS_HID_256f] = 126,
	[BNXT_ULP_CLASS_HID_4937] = 127,
	[BNXT_ULP_CLASS_HID_111b] = 128,
	[BNXT_ULP_CLASS_HID_5f4b] = 129,
	[BNXT_ULP_CLASS_HID_275f] = 130,
	[BNXT_ULP_CLASS_HID_4b67] = 131,
	[BNXT_ULP_CLASS_HID_134b] = 132,
	[BNXT_ULP_CLASS_HID_1683] = 133,
	[BNXT_ULP_CLASS_HID_475b] = 134,
	[BNXT_ULP_CLASS_HID_02bf] = 135,
	[BNXT_ULP_CLASS_HID_3377] = 136,
	[BNXT_ULP_CLASS_HID_19db] = 137,
	[BNXT_ULP_CLASS_HID_4a93] = 138,
	[BNXT_ULP_CLASS_HID_05f7] = 139,
	[BNXT_ULP_CLASS_HID_368f] = 140,
	[BNXT_ULP_CLASS_HID_39c7] = 141,
	[BNXT_ULP_CLASS_HID_022b] = 142,
	[BNXT_ULP_CLASS_HID_25f3] = 143,
	[BNXT_ULP_CLASS_HID_568b] = 144,
	[BNXT_ULP_CLASS_HID_3c37] = 145,
	[BNXT_ULP_CLASS_HID_041b] = 146,
	[BNXT_ULP_CLASS_HID_2823] = 147,
	[BNXT_ULP_CLASS_HID_58fb] = 148,
	[BNXT_ULP_CLASS_HID_5c33] = 149,
	[BNXT_ULP_CLASS_HID_2407] = 150,
	[BNXT_ULP_CLASS_HID_482f] = 151,
	[BNXT_ULP_CLASS_HID_1033] = 152,
	[BNXT_ULP_CLASS_HID_3887] = 153,
	[BNXT_ULP_CLASS_HID_00bb] = 154,
	[BNXT_ULP_CLASS_HID_2493] = 155,
	[BNXT_ULP_CLASS_HID_55db] = 156,
	[BNXT_ULP_CLASS_HID_5043] = 157,
	[BNXT_ULP_CLASS_HID_1877] = 158,
	[BNXT_ULP_CLASS_HID_3baf] = 159,
	[BNXT_ULP_CLASS_HID_0443] = 160,
	[BNXT_ULP_CLASS_HID_5883] = 161,
	[BNXT_ULP_CLASS_HID_20b7] = 162,
	[BNXT_ULP_CLASS_HID_44ef] = 163,
	[BNXT_ULP_CLASS_HID_0c83] = 164,
	[BNXT_ULP_CLASS_HID_070b] = 165,
	[BNXT_ULP_CLASS_HID_3873] = 166,
	[BNXT_ULP_CLASS_HID_5bab] = 167,
	[BNXT_ULP_CLASS_HID_245f] = 168,
	[BNXT_ULP_CLASS_HID_142b] = 169,
	[BNXT_ULP_CLASS_HID_4513] = 170,
	[BNXT_ULP_CLASS_HID_0037] = 171,
	[BNXT_ULP_CLASS_HID_317f] = 172,
	[BNXT_ULP_CLASS_HID_2be7] = 173,
	[BNXT_ULP_CLASS_HID_5c2f] = 174,
	[BNXT_ULP_CLASS_HID_17f3] = 175,
	[BNXT_ULP_CLASS_HID_483b] = 176,
	[BNXT_ULP_CLASS_HID_3427] = 177,
	[BNXT_ULP_CLASS_HID_656f] = 178,
	[BNXT_ULP_CLASS_HID_2033] = 179,
	[BNXT_ULP_CLASS_HID_517b] = 180,
	[BNXT_ULP_CLASS_HID_4be3] = 181,
	[BNXT_ULP_CLASS_HID_1397] = 182,
	[BNXT_ULP_CLASS_HID_37cf] = 183,
	[BNXT_ULP_CLASS_HID_6837] = 184,
	[BNXT_ULP_CLASS_HID_3d7f] = 185,
	[BNXT_ULP_CLASS_HID_0503] = 186,
	[BNXT_ULP_CLASS_HID_296b] = 187,
	[BNXT_ULP_CLASS_HID_59a3] = 188,
	[BNXT_ULP_CLASS_HID_5d7b] = 189,
	[BNXT_ULP_CLASS_HID_250f] = 190,
	[BNXT_ULP_CLASS_HID_4957] = 191,
	[BNXT_ULP_CLASS_HID_117b] = 192,
	[BNXT_ULP_CLASS_HID_5f2b] = 193,
	[BNXT_ULP_CLASS_HID_273f] = 194,
	[BNXT_ULP_CLASS_HID_4b07] = 195,
	[BNXT_ULP_CLASS_HID_132b] = 196,
	[BNXT_ULP_CLASS_HID_16e3] = 197,
	[BNXT_ULP_CLASS_HID_473b] = 198,
	[BNXT_ULP_CLASS_HID_02df] = 199,
	[BNXT_ULP_CLASS_HID_3317] = 200,
	[BNXT_ULP_CLASS_HID_19bb] = 201,
	[BNXT_ULP_CLASS_HID_4af3] = 202,
	[BNXT_ULP_CLASS_HID_0597] = 203,
	[BNXT_ULP_CLASS_HID_36ef] = 204,
	[BNXT_ULP_CLASS_HID_39a7] = 205,
	[BNXT_ULP_CLASS_HID_024b] = 206,
	[BNXT_ULP_CLASS_HID_2593] = 207,
	[BNXT_ULP_CLASS_HID_56eb] = 208,
	[BNXT_ULP_CLASS_HID_3c57] = 209,
	[BNXT_ULP_CLASS_HID_047b] = 210,
	[BNXT_ULP_CLASS_HID_2843] = 211,
	[BNXT_ULP_CLASS_HID_589b] = 212,
	[BNXT_ULP_CLASS_HID_5c53] = 213,
	[BNXT_ULP_CLASS_HID_2467] = 214,
	[BNXT_ULP_CLASS_HID_484f] = 215,
	[BNXT_ULP_CLASS_HID_1053] = 216,
	[BNXT_ULP_CLASS_HID_5ce1] = 217,
	[BNXT_ULP_CLASS_HID_4579] = 218,
	[BNXT_ULP_CLASS_HID_1735] = 219,
	[BNXT_ULP_CLASS_HID_45bd] = 220,
	[BNXT_ULP_CLASS_HID_3feb] = 221,
	[BNXT_ULP_CLASS_HID_2bf7] = 222,
	[BNXT_ULP_CLASS_HID_5727] = 223,
	[BNXT_ULP_CLASS_HID_4333] = 224,
	[BNXT_ULP_CLASS_HID_4453] = 225,
	[BNXT_ULP_CLASS_HID_304f] = 226,
	[BNXT_ULP_CLASS_HID_645f] = 227,
	[BNXT_ULP_CLASS_HID_504b] = 228,
	[BNXT_ULP_CLASS_HID_5cc1] = 229,
	[BNXT_ULP_CLASS_HID_4559] = 230,
	[BNXT_ULP_CLASS_HID_2285] = 231,
	[BNXT_ULP_CLASS_HID_0b1d] = 232,
	[BNXT_ULP_CLASS_HID_0b49] = 233,
	[BNXT_ULP_CLASS_HID_5c95] = 234,
	[BNXT_ULP_CLASS_HID_39c1] = 235,
	[BNXT_ULP_CLASS_HID_2259] = 236,
	[BNXT_ULP_CLASS_HID_1715] = 237,
	[BNXT_ULP_CLASS_HID_459d] = 238,
	[BNXT_ULP_CLASS_HID_571d] = 239,
	[BNXT_ULP_CLASS_HID_1cd1] = 240,
	[BNXT_ULP_CLASS_HID_3711] = 241,
	[BNXT_ULP_CLASS_HID_6599] = 242,
	[BNXT_ULP_CLASS_HID_0e55] = 243,
	[BNXT_ULP_CLASS_HID_3cdd] = 244,
	[BNXT_ULP_CLASS_HID_5ca1] = 245,
	[BNXT_ULP_CLASS_HID_4539] = 246,
	[BNXT_ULP_CLASS_HID_22e5] = 247,
	[BNXT_ULP_CLASS_HID_0b7d] = 248,
	[BNXT_ULP_CLASS_HID_0b29] = 249,
	[BNXT_ULP_CLASS_HID_5cf5] = 250,
	[BNXT_ULP_CLASS_HID_39a1] = 251,
	[BNXT_ULP_CLASS_HID_2239] = 252,
	[BNXT_ULP_CLASS_HID_1775] = 253,
	[BNXT_ULP_CLASS_HID_45fd] = 254,
	[BNXT_ULP_CLASS_HID_577d] = 255,
	[BNXT_ULP_CLASS_HID_1cb1] = 256,
	[BNXT_ULP_CLASS_HID_3771] = 257,
	[BNXT_ULP_CLASS_HID_65f9] = 258,
	[BNXT_ULP_CLASS_HID_0e35] = 259,
	[BNXT_ULP_CLASS_HID_3cbd] = 260,
	[BNXT_ULP_CLASS_HID_3fcb] = 261,
	[BNXT_ULP_CLASS_HID_2bd7] = 262,
	[BNXT_ULP_CLASS_HID_5707] = 263,
	[BNXT_ULP_CLASS_HID_4313] = 264,
	[BNXT_ULP_CLASS_HID_5fc7] = 265,
	[BNXT_ULP_CLASS_HID_4bd3] = 266,
	[BNXT_ULP_CLASS_HID_0e4f] = 267,
	[BNXT_ULP_CLASS_HID_632f] = 268,
	[BNXT_ULP_CLASS_HID_1baf] = 269,
	[BNXT_ULP_CLASS_HID_07bb] = 270,
	[BNXT_ULP_CLASS_HID_32eb] = 271,
	[BNXT_ULP_CLASS_HID_1ef7] = 272,
	[BNXT_ULP_CLASS_HID_3bab] = 273,
	[BNXT_ULP_CLASS_HID_27b7] = 274,
	[BNXT_ULP_CLASS_HID_52e7] = 275,
	[BNXT_ULP_CLASS_HID_3ef3] = 276,
	[BNXT_ULP_CLASS_HID_4473] = 277,
	[BNXT_ULP_CLASS_HID_306f] = 278,
	[BNXT_ULP_CLASS_HID_647f] = 279,
	[BNXT_ULP_CLASS_HID_506b] = 280,
	[BNXT_ULP_CLASS_HID_66af] = 281,
	[BNXT_ULP_CLASS_HID_525b] = 282,
	[BNXT_ULP_CLASS_HID_1de7] = 283,
	[BNXT_ULP_CLASS_HID_0993] = 284,
	[BNXT_ULP_CLASS_HID_213f] = 285,
	[BNXT_ULP_CLASS_HID_0d2b] = 286,
	[BNXT_ULP_CLASS_HID_413b] = 287,
	[BNXT_ULP_CLASS_HID_2cd7] = 288,
	[BNXT_ULP_CLASS_HID_436b] = 289,
	[BNXT_ULP_CLASS_HID_2f07] = 290,
	[BNXT_ULP_CLASS_HID_6317] = 291,
	[BNXT_ULP_CLASS_HID_4f03] = 292,
	[BNXT_ULP_CLASS_HID_3fab] = 293,
	[BNXT_ULP_CLASS_HID_2bb7] = 294,
	[BNXT_ULP_CLASS_HID_5767] = 295,
	[BNXT_ULP_CLASS_HID_4373] = 296,
	[BNXT_ULP_CLASS_HID_5fa7] = 297,
	[BNXT_ULP_CLASS_HID_4bb3] = 298,
	[BNXT_ULP_CLASS_HID_0e2f] = 299,
	[BNXT_ULP_CLASS_HID_634f] = 300,
	[BNXT_ULP_CLASS_HID_1bcf] = 301,
	[BNXT_ULP_CLASS_HID_07db] = 302,
	[BNXT_ULP_CLASS_HID_328b] = 303,
	[BNXT_ULP_CLASS_HID_1e97] = 304,
	[BNXT_ULP_CLASS_HID_3bcb] = 305,
	[BNXT_ULP_CLASS_HID_27d7] = 306,
	[BNXT_ULP_CLASS_HID_5287] = 307,
	[BNXT_ULP_CLASS_HID_3e93] = 308,
	[BNXT_ULP_CLASS_HID_4413] = 309,
	[BNXT_ULP_CLASS_HID_300f] = 310,
	[BNXT_ULP_CLASS_HID_641f] = 311,
	[BNXT_ULP_CLASS_HID_500b] = 312,
	[BNXT_ULP_CLASS_HID_66cf] = 313,
	[BNXT_ULP_CLASS_HID_523b] = 314,
	[BNXT_ULP_CLASS_HID_1d87] = 315,
	[BNXT_ULP_CLASS_HID_09f3] = 316,
	[BNXT_ULP_CLASS_HID_215f] = 317,
	[BNXT_ULP_CLASS_HID_0d4b] = 318,
	[BNXT_ULP_CLASS_HID_415b] = 319,
	[BNXT_ULP_CLASS_HID_2cb7] = 320,
	[BNXT_ULP_CLASS_HID_430b] = 321,
	[BNXT_ULP_CLASS_HID_2f67] = 322,
	[BNXT_ULP_CLASS_HID_6377] = 323,
	[BNXT_ULP_CLASS_HID_4f63] = 324,
	[BNXT_ULP_CLASS_HID_29b5] = 325,
	[BNXT_ULP_CLASS_HID_29ad] = 326,
	[BNXT_ULP_CLASS_HID_29b7] = 327,
	[BNXT_ULP_CLASS_HID_1583] = 328,
	[BNXT_ULP_CLASS_HID_29af] = 329,
	[BNXT_ULP_CLASS_HID_159b] = 330,
	[BNXT_ULP_CLASS_HID_2995] = 331,
	[BNXT_ULP_CLASS_HID_298d] = 332,
	[BNXT_ULP_CLASS_HID_29f5] = 333,
	[BNXT_ULP_CLASS_HID_29ed] = 334,
	[BNXT_ULP_CLASS_HID_2997] = 335,
	[BNXT_ULP_CLASS_HID_15a3] = 336,
	[BNXT_ULP_CLASS_HID_298f] = 337,
	[BNXT_ULP_CLASS_HID_15bb] = 338,
	[BNXT_ULP_CLASS_HID_29f7] = 339,
	[BNXT_ULP_CLASS_HID_15c3] = 340,
	[BNXT_ULP_CLASS_HID_29ef] = 341,
	[BNXT_ULP_CLASS_HID_15db] = 342,
	[BNXT_ULP_CLASS_HID_1151] = 343,
	[BNXT_ULP_CLASS_HID_315d] = 344,
	[BNXT_ULP_CLASS_HID_34c6] = 345,
	[BNXT_ULP_CLASS_HID_0c22] = 346,
	[BNXT_ULP_CLASS_HID_1cbe] = 347,
	[BNXT_ULP_CLASS_HID_179a] = 348,
	[BNXT_ULP_CLASS_HID_59be] = 349,
	[BNXT_ULP_CLASS_HID_515a] = 350,
	[BNXT_ULP_CLASS_HID_1c72] = 351,
	[BNXT_ULP_CLASS_HID_171e] = 352,
	[BNXT_ULP_CLASS_HID_19c8] = 353,
	[BNXT_ULP_CLASS_HID_112c] = 354,
	[BNXT_ULP_CLASS_HID_4d68] = 355,
	[BNXT_ULP_CLASS_HID_444c] = 356,
	[BNXT_ULP_CLASS_HID_0e8c] = 357,
	[BNXT_ULP_CLASS_HID_09e0] = 358,
	[BNXT_ULP_CLASS_HID_1af0] = 359,
	[BNXT_ULP_CLASS_HID_15d4] = 360,
	[BNXT_ULP_CLASS_HID_1dd0] = 361,
	[BNXT_ULP_CLASS_HID_14f4] = 362,
	[BNXT_ULP_CLASS_HID_70b0] = 363,
	[BNXT_ULP_CLASS_HID_4854] = 364,
	[BNXT_ULP_CLASS_HID_3dd4] = 365,
	[BNXT_ULP_CLASS_HID_34f8] = 366,
	[BNXT_ULP_CLASS_HID_09e8] = 367,
	[BNXT_ULP_CLASS_HID_008c] = 368,
	[BNXT_ULP_CLASS_HID_34e6] = 369,
	[BNXT_ULP_CLASS_HID_0c02] = 370,
	[BNXT_ULP_CLASS_HID_1c9e] = 371,
	[BNXT_ULP_CLASS_HID_17ba] = 372,
	[BNXT_ULP_CLASS_HID_429e] = 373,
	[BNXT_ULP_CLASS_HID_5dba] = 374,
	[BNXT_ULP_CLASS_HID_2a16] = 375,
	[BNXT_ULP_CLASS_HID_2532] = 376,
	[BNXT_ULP_CLASS_HID_2da2] = 377,
	[BNXT_ULP_CLASS_HID_24fe] = 378,
	[BNXT_ULP_CLASS_HID_355a] = 379,
	[BNXT_ULP_CLASS_HID_0c76] = 380,
	[BNXT_ULP_CLASS_HID_13e6] = 381,
	[BNXT_ULP_CLASS_HID_7276] = 382,
	[BNXT_ULP_CLASS_HID_42d2] = 383,
	[BNXT_ULP_CLASS_HID_5dee] = 384,
	[BNXT_ULP_CLASS_HID_59de] = 385,
	[BNXT_ULP_CLASS_HID_513a] = 386,
	[BNXT_ULP_CLASS_HID_1c12] = 387,
	[BNXT_ULP_CLASS_HID_177e] = 388,
	[BNXT_ULP_CLASS_HID_0e92] = 389,
	[BNXT_ULP_CLASS_HID_09fe] = 390,
	[BNXT_ULP_CLASS_HID_5c1a] = 391,
	[BNXT_ULP_CLASS_HID_5746] = 392,
	[BNXT_ULP_CLASS_HID_79da] = 393,
	[BNXT_ULP_CLASS_HID_7106] = 394,
	[BNXT_ULP_CLASS_HID_3c1e] = 395,
	[BNXT_ULP_CLASS_HID_377a] = 396,
	[BNXT_ULP_CLASS_HID_2e9e] = 397,
	[BNXT_ULP_CLASS_HID_29fa] = 398,
	[BNXT_ULP_CLASS_HID_14d2] = 399,
	[BNXT_ULP_CLASS_HID_7742] = 400,
	[BNXT_ULP_CLASS_HID_3706] = 401,
	[BNXT_ULP_CLASS_HID_0fe2] = 402,
	[BNXT_ULP_CLASS_HID_1f7e] = 403,
	[BNXT_ULP_CLASS_HID_145a] = 404,
	[BNXT_ULP_CLASS_HID_417e] = 405,
	[BNXT_ULP_CLASS_HID_5e5a] = 406,
	[BNXT_ULP_CLASS_HID_29f6] = 407,
	[BNXT_ULP_CLASS_HID_26d2] = 408,
	[BNXT_ULP_CLASS_HID_2e42] = 409,
	[BNXT_ULP_CLASS_HID_271e] = 410,
	[BNXT_ULP_CLASS_HID_36ba] = 411,
	[BNXT_ULP_CLASS_HID_0f96] = 412,
	[BNXT_ULP_CLASS_HID_1006] = 413,
	[BNXT_ULP_CLASS_HID_7196] = 414,
	[BNXT_ULP_CLASS_HID_4132] = 415,
	[BNXT_ULP_CLASS_HID_5e0e] = 416,
	[BNXT_ULP_CLASS_HID_59fe] = 417,
	[BNXT_ULP_CLASS_HID_511a] = 418,
	[BNXT_ULP_CLASS_HID_1c32] = 419,
	[BNXT_ULP_CLASS_HID_175e] = 420,
	[BNXT_ULP_CLASS_HID_0eb2] = 421,
	[BNXT_ULP_CLASS_HID_09de] = 422,
	[BNXT_ULP_CLASS_HID_5c3a] = 423,
	[BNXT_ULP_CLASS_HID_5766] = 424,
	[BNXT_ULP_CLASS_HID_79fa] = 425,
	[BNXT_ULP_CLASS_HID_7126] = 426,
	[BNXT_ULP_CLASS_HID_3c3e] = 427,
	[BNXT_ULP_CLASS_HID_375a] = 428,
	[BNXT_ULP_CLASS_HID_2ebe] = 429,
	[BNXT_ULP_CLASS_HID_29da] = 430,
	[BNXT_ULP_CLASS_HID_14f2] = 431,
	[BNXT_ULP_CLASS_HID_7762] = 432,
	[BNXT_ULP_CLASS_HID_19e8] = 433,
	[BNXT_ULP_CLASS_HID_110c] = 434,
	[BNXT_ULP_CLASS_HID_4d48] = 435,
	[BNXT_ULP_CLASS_HID_446c] = 436,
	[BNXT_ULP_CLASS_HID_0eac] = 437,
	[BNXT_ULP_CLASS_HID_09c0] = 438,
	[BNXT_ULP_CLASS_HID_1ad0] = 439,
	[BNXT_ULP_CLASS_HID_15f4] = 440,
	[BNXT_ULP_CLASS_HID_39ec] = 441,
	[BNXT_ULP_CLASS_HID_3100] = 442,
	[BNXT_ULP_CLASS_HID_0210] = 443,
	[BNXT_ULP_CLASS_HID_1d34] = 444,
	[BNXT_ULP_CLASS_HID_2ea0] = 445,
	[BNXT_ULP_CLASS_HID_29c4] = 446,
	[BNXT_ULP_CLASS_HID_3ad4] = 447,
	[BNXT_ULP_CLASS_HID_35e8] = 448,
	[BNXT_ULP_CLASS_HID_5d80] = 449,
	[BNXT_ULP_CLASS_HID_54a4] = 450,
	[BNXT_ULP_CLASS_HID_29b4] = 451,
	[BNXT_ULP_CLASS_HID_20c8] = 452,
	[BNXT_ULP_CLASS_HID_7244] = 453,
	[BNXT_ULP_CLASS_HID_4d98] = 454,
	[BNXT_ULP_CLASS_HID_5e68] = 455,
	[BNXT_ULP_CLASS_HID_598c] = 456,
	[BNXT_ULP_CLASS_HID_1248] = 457,
	[BNXT_ULP_CLASS_HID_74d8] = 458,
	[BNXT_ULP_CLASS_HID_49a8] = 459,
	[BNXT_ULP_CLASS_HID_40cc] = 460,
	[BNXT_ULP_CLASS_HID_0b0c] = 461,
	[BNXT_ULP_CLASS_HID_0220] = 462,
	[BNXT_ULP_CLASS_HID_1730] = 463,
	[BNXT_ULP_CLASS_HID_7980] = 464,
	[BNXT_ULP_CLASS_HID_1db0] = 465,
	[BNXT_ULP_CLASS_HID_1494] = 466,
	[BNXT_ULP_CLASS_HID_70d0] = 467,
	[BNXT_ULP_CLASS_HID_4834] = 468,
	[BNXT_ULP_CLASS_HID_3db4] = 469,
	[BNXT_ULP_CLASS_HID_3498] = 470,
	[BNXT_ULP_CLASS_HID_0988] = 471,
	[BNXT_ULP_CLASS_HID_00ec] = 472,
	[BNXT_ULP_CLASS_HID_3f44] = 473,
	[BNXT_ULP_CLASS_HID_36a8] = 474,
	[BNXT_ULP_CLASS_HID_0b58] = 475,
	[BNXT_ULP_CLASS_HID_02bc] = 476,
	[BNXT_ULP_CLASS_HID_5f48] = 477,
	[BNXT_ULP_CLASS_HID_56ac] = 478,
	[BNXT_ULP_CLASS_HID_2b5c] = 479,
	[BNXT_ULP_CLASS_HID_2280] = 480,
	[BNXT_ULP_CLASS_HID_4000] = 481,
	[BNXT_ULP_CLASS_HID_5b64] = 482,
	[BNXT_ULP_CLASS_HID_2c14] = 483,
	[BNXT_ULP_CLASS_HID_2778] = 484,
	[BNXT_ULP_CLASS_HID_18f8] = 485,
	[BNXT_ULP_CLASS_HID_13dc] = 486,
	[BNXT_ULP_CLASS_HID_4c18] = 487,
	[BNXT_ULP_CLASS_HID_477c] = 488,
	[BNXT_ULP_CLASS_HID_1a88] = 489,
	[BNXT_ULP_CLASS_HID_15ec] = 490,
	[BNXT_ULP_CLASS_HID_4e28] = 491,
	[BNXT_ULP_CLASS_HID_490c] = 492,
	[BNXT_ULP_CLASS_HID_3a8c] = 493,
	[BNXT_ULP_CLASS_HID_35f0] = 494,
	[BNXT_ULP_CLASS_HID_06e0] = 495,
	[BNXT_ULP_CLASS_HID_01c4] = 496,
	[BNXT_ULP_CLASS_HID_1a08] = 497,
	[BNXT_ULP_CLASS_HID_12ec] = 498,
	[BNXT_ULP_CLASS_HID_4ea8] = 499,
	[BNXT_ULP_CLASS_HID_478c] = 500,
	[BNXT_ULP_CLASS_HID_0d4c] = 501,
	[BNXT_ULP_CLASS_HID_0a20] = 502,
	[BNXT_ULP_CLASS_HID_1930] = 503,
	[BNXT_ULP_CLASS_HID_1614] = 504,
	[BNXT_ULP_CLASS_HID_3a0c] = 505,
	[BNXT_ULP_CLASS_HID_32e0] = 506,
	[BNXT_ULP_CLASS_HID_01f0] = 507,
	[BNXT_ULP_CLASS_HID_1ed4] = 508,
	[BNXT_ULP_CLASS_HID_2d40] = 509,
	[BNXT_ULP_CLASS_HID_2a24] = 510,
	[BNXT_ULP_CLASS_HID_3934] = 511,
	[BNXT_ULP_CLASS_HID_3608] = 512,
	[BNXT_ULP_CLASS_HID_5e60] = 513,
	[BNXT_ULP_CLASS_HID_5744] = 514,
	[BNXT_ULP_CLASS_HID_2a54] = 515,
	[BNXT_ULP_CLASS_HID_2328] = 516,
	[BNXT_ULP_CLASS_HID_71a4] = 517,
	[BNXT_ULP_CLASS_HID_4e78] = 518,
	[BNXT_ULP_CLASS_HID_5d88] = 519,
	[BNXT_ULP_CLASS_HID_5a6c] = 520,
	[BNXT_ULP_CLASS_HID_11a8] = 521,
	[BNXT_ULP_CLASS_HID_7738] = 522,
	[BNXT_ULP_CLASS_HID_4a48] = 523,
	[BNXT_ULP_CLASS_HID_432c] = 524,
	[BNXT_ULP_CLASS_HID_08ec] = 525,
	[BNXT_ULP_CLASS_HID_01c0] = 526,
	[BNXT_ULP_CLASS_HID_14d0] = 527,
	[BNXT_ULP_CLASS_HID_7a60] = 528,
	[BNXT_ULP_CLASS_HID_1d90] = 529,
	[BNXT_ULP_CLASS_HID_14b4] = 530,
	[BNXT_ULP_CLASS_HID_70f0] = 531,
	[BNXT_ULP_CLASS_HID_4814] = 532,
	[BNXT_ULP_CLASS_HID_3d94] = 533,
	[BNXT_ULP_CLASS_HID_34b8] = 534,
	[BNXT_ULP_CLASS_HID_09a8] = 535,
	[BNXT_ULP_CLASS_HID_00cc] = 536,
	[BNXT_ULP_CLASS_HID_3f64] = 537,
	[BNXT_ULP_CLASS_HID_3688] = 538,
	[BNXT_ULP_CLASS_HID_0b78] = 539,
	[BNXT_ULP_CLASS_HID_029c] = 540,
	[BNXT_ULP_CLASS_HID_5f68] = 541,
	[BNXT_ULP_CLASS_HID_568c] = 542,
	[BNXT_ULP_CLASS_HID_2b7c] = 543,
	[BNXT_ULP_CLASS_HID_22a0] = 544,
	[BNXT_ULP_CLASS_HID_4020] = 545,
	[BNXT_ULP_CLASS_HID_5b44] = 546,
	[BNXT_ULP_CLASS_HID_2c34] = 547,
	[BNXT_ULP_CLASS_HID_2758] = 548,
	[BNXT_ULP_CLASS_HID_18d8] = 549,
	[BNXT_ULP_CLASS_HID_13fc] = 550,
	[BNXT_ULP_CLASS_HID_4c38] = 551,
	[BNXT_ULP_CLASS_HID_475c] = 552,
	[BNXT_ULP_CLASS_HID_1aa8] = 553,
	[BNXT_ULP_CLASS_HID_15cc] = 554,
	[BNXT_ULP_CLASS_HID_4e08] = 555,
	[BNXT_ULP_CLASS_HID_492c] = 556,
	[BNXT_ULP_CLASS_HID_3aac] = 557,
	[BNXT_ULP_CLASS_HID_35d0] = 558,
	[BNXT_ULP_CLASS_HID_06c0] = 559,
	[BNXT_ULP_CLASS_HID_01e4] = 560,
	[BNXT_ULP_CLASS_HID_4d32] = 561,
	[BNXT_ULP_CLASS_HID_54aa] = 562,
	[BNXT_ULP_CLASS_HID_0686] = 563,
	[BNXT_ULP_CLASS_HID_540e] = 564,
	[BNXT_ULP_CLASS_HID_2e3c] = 565,
	[BNXT_ULP_CLASS_HID_3a20] = 566,
	[BNXT_ULP_CLASS_HID_46f0] = 567,
	[BNXT_ULP_CLASS_HID_52e4] = 568,
	[BNXT_ULP_CLASS_HID_55e4] = 569,
	[BNXT_ULP_CLASS_HID_21f8] = 570,
	[BNXT_ULP_CLASS_HID_75e8] = 571,
	[BNXT_ULP_CLASS_HID_41fc] = 572,
	[BNXT_ULP_CLASS_HID_4d12] = 573,
	[BNXT_ULP_CLASS_HID_548a] = 574,
	[BNXT_ULP_CLASS_HID_3356] = 575,
	[BNXT_ULP_CLASS_HID_1ace] = 576,
	[BNXT_ULP_CLASS_HID_1a9a] = 577,
	[BNXT_ULP_CLASS_HID_4d46] = 578,
	[BNXT_ULP_CLASS_HID_2812] = 579,
	[BNXT_ULP_CLASS_HID_338a] = 580,
	[BNXT_ULP_CLASS_HID_06e6] = 581,
	[BNXT_ULP_CLASS_HID_546e] = 582,
	[BNXT_ULP_CLASS_HID_46ee] = 583,
	[BNXT_ULP_CLASS_HID_0d22] = 584,
	[BNXT_ULP_CLASS_HID_26e2] = 585,
	[BNXT_ULP_CLASS_HID_746a] = 586,
	[BNXT_ULP_CLASS_HID_1fa6] = 587,
	[BNXT_ULP_CLASS_HID_2d2e] = 588,
	[BNXT_ULP_CLASS_HID_4ef2] = 589,
	[BNXT_ULP_CLASS_HID_576a] = 590,
	[BNXT_ULP_CLASS_HID_30b6] = 591,
	[BNXT_ULP_CLASS_HID_192e] = 592,
	[BNXT_ULP_CLASS_HID_197a] = 593,
	[BNXT_ULP_CLASS_HID_4ea6] = 594,
	[BNXT_ULP_CLASS_HID_2bf2] = 595,
	[BNXT_ULP_CLASS_HID_306a] = 596,
	[BNXT_ULP_CLASS_HID_06c6] = 597,
	[BNXT_ULP_CLASS_HID_544e] = 598,
	[BNXT_ULP_CLASS_HID_46ce] = 599,
	[BNXT_ULP_CLASS_HID_0d02] = 600,
	[BNXT_ULP_CLASS_HID_26c2] = 601,
	[BNXT_ULP_CLASS_HID_744a] = 602,
	[BNXT_ULP_CLASS_HID_1f86] = 603,
	[BNXT_ULP_CLASS_HID_2d0e] = 604,
	[BNXT_ULP_CLASS_HID_2e1c] = 605,
	[BNXT_ULP_CLASS_HID_3a00] = 606,
	[BNXT_ULP_CLASS_HID_46d0] = 607,
	[BNXT_ULP_CLASS_HID_52c4] = 608,
	[BNXT_ULP_CLASS_HID_4e10] = 609,
	[BNXT_ULP_CLASS_HID_5a04] = 610,
	[BNXT_ULP_CLASS_HID_1f98] = 611,
	[BNXT_ULP_CLASS_HID_72f8] = 612,
	[BNXT_ULP_CLASS_HID_0a78] = 613,
	[BNXT_ULP_CLASS_HID_166c] = 614,
	[BNXT_ULP_CLASS_HID_233c] = 615,
	[BNXT_ULP_CLASS_HID_0f20] = 616,
	[BNXT_ULP_CLASS_HID_2a7c] = 617,
	[BNXT_ULP_CLASS_HID_3660] = 618,
	[BNXT_ULP_CLASS_HID_4330] = 619,
	[BNXT_ULP_CLASS_HID_2f24] = 620,
	[BNXT_ULP_CLASS_HID_5584] = 621,
	[BNXT_ULP_CLASS_HID_2198] = 622,
	[BNXT_ULP_CLASS_HID_7588] = 623,
	[BNXT_ULP_CLASS_HID_419c] = 624,
	[BNXT_ULP_CLASS_HID_7758] = 625,
	[BNXT_ULP_CLASS_HID_43ac] = 626,
	[BNXT_ULP_CLASS_HID_0c10] = 627,
	[BNXT_ULP_CLASS_HID_1864] = 628,
	[BNXT_ULP_CLASS_HID_30c8] = 629,
	[BNXT_ULP_CLASS_HID_1cdc] = 630,
	[BNXT_ULP_CLASS_HID_50cc] = 631,
	[BNXT_ULP_CLASS_HID_3d20] = 632,
	[BNXT_ULP_CLASS_HID_529c] = 633,
	[BNXT_ULP_CLASS_HID_3ef0] = 634,
	[BNXT_ULP_CLASS_HID_72e0] = 635,
	[BNXT_ULP_CLASS_HID_5ef4] = 636,
	[BNXT_ULP_CLASS_HID_2dfc] = 637,
	[BNXT_ULP_CLASS_HID_39e0] = 638,
	[BNXT_ULP_CLASS_HID_4530] = 639,
	[BNXT_ULP_CLASS_HID_5124] = 640,
	[BNXT_ULP_CLASS_HID_4df0] = 641,
	[BNXT_ULP_CLASS_HID_59e4] = 642,
	[BNXT_ULP_CLASS_HID_1c78] = 643,
	[BNXT_ULP_CLASS_HID_7118] = 644,
	[BNXT_ULP_CLASS_HID_0998] = 645,
	[BNXT_ULP_CLASS_HID_158c] = 646,
	[BNXT_ULP_CLASS_HID_20dc] = 647,
	[BNXT_ULP_CLASS_HID_0cc0] = 648,
	[BNXT_ULP_CLASS_HID_299c] = 649,
	[BNXT_ULP_CLASS_HID_3580] = 650,
	[BNXT_ULP_CLASS_HID_40d0] = 651,
	[BNXT_ULP_CLASS_HID_2cc4] = 652,
	[BNXT_ULP_CLASS_HID_55a4] = 653,
	[BNXT_ULP_CLASS_HID_21b8] = 654,
	[BNXT_ULP_CLASS_HID_75a8] = 655,
	[BNXT_ULP_CLASS_HID_41bc] = 656,
	[BNXT_ULP_CLASS_HID_7778] = 657,
	[BNXT_ULP_CLASS_HID_438c] = 658,
	[BNXT_ULP_CLASS_HID_0c30] = 659,
	[BNXT_ULP_CLASS_HID_1844] = 660,
	[BNXT_ULP_CLASS_HID_30e8] = 661,
	[BNXT_ULP_CLASS_HID_1cfc] = 662,
	[BNXT_ULP_CLASS_HID_50ec] = 663,
	[BNXT_ULP_CLASS_HID_3d00] = 664,
	[BNXT_ULP_CLASS_HID_52bc] = 665,
	[BNXT_ULP_CLASS_HID_3ed0] = 666,
	[BNXT_ULP_CLASS_HID_72c0] = 667,
	[BNXT_ULP_CLASS_HID_5ed4] = 668,
	[BNXT_ULP_CLASS_HID_3866] = 669,
	[BNXT_ULP_CLASS_HID_381e] = 670,
	[BNXT_ULP_CLASS_HID_3860] = 671,
	[BNXT_ULP_CLASS_HID_0454] = 672,
	[BNXT_ULP_CLASS_HID_3818] = 673,
	[BNXT_ULP_CLASS_HID_042c] = 674,
	[BNXT_ULP_CLASS_HID_3846] = 675,
	[BNXT_ULP_CLASS_HID_387e] = 676,
	[BNXT_ULP_CLASS_HID_3ba6] = 677,
	[BNXT_ULP_CLASS_HID_385e] = 678,
	[BNXT_ULP_CLASS_HID_3840] = 679,
	[BNXT_ULP_CLASS_HID_0474] = 680,
	[BNXT_ULP_CLASS_HID_3878] = 681,
	[BNXT_ULP_CLASS_HID_044c] = 682,
	[BNXT_ULP_CLASS_HID_3ba0] = 683,
	[BNXT_ULP_CLASS_HID_0794] = 684,
	[BNXT_ULP_CLASS_HID_3858] = 685,
	[BNXT_ULP_CLASS_HID_046c] = 686
};

/* Array for the proto matcher list */
struct bnxt_ulp_class_match_info ulp_class_match_list[] = {
	[1] = {
	.class_hid = BNXT_ULP_CLASS_HID_55dd,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[2] = {
	.class_hid = BNXT_ULP_CLASS_HID_1df1,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[3] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e55,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[4] = {
	.class_hid = BNXT_ULP_CLASS_HID_0649,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[5] = {
	.class_hid = BNXT_ULP_CLASS_HID_1011,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[6] = {
	.class_hid = BNXT_ULP_CLASS_HID_40e9,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16392,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[7] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e99,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[8] = {
	.class_hid = BNXT_ULP_CLASS_HID_06ad,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24584,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[9] = {
	.class_hid = BNXT_ULP_CLASS_HID_38c7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[10] = {
	.class_hid = BNXT_ULP_CLASS_HID_00fb,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32776,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[11] = {
	.class_hid = BNXT_ULP_CLASS_HID_24d3,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[12] = {
	.class_hid = BNXT_ULP_CLASS_HID_559b,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[13] = {
	.class_hid = BNXT_ULP_CLASS_HID_5003,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[14] = {
	.class_hid = BNXT_ULP_CLASS_HID_1837,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49160,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[15] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bef,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[16] = {
	.class_hid = BNXT_ULP_CLASS_HID_0403,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[17] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d3f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[18] = {
	.class_hid = BNXT_ULP_CLASS_HID_0543,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131080,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[19] = {
	.class_hid = BNXT_ULP_CLASS_HID_292b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[20] = {
	.class_hid = BNXT_ULP_CLASS_HID_59e3,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[21] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d3b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[22] = {
	.class_hid = BNXT_ULP_CLASS_HID_254f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196616,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[23] = {
	.class_hid = BNXT_ULP_CLASS_HID_4917,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[24] = {
	.class_hid = BNXT_ULP_CLASS_HID_113b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196680,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[25] = {
	.class_hid = BNXT_ULP_CLASS_HID_55fd,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[26] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dd1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[27] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e75,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[28] = {
	.class_hid = BNXT_ULP_CLASS_HID_0669,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[29] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ba1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[30] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c69,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12296,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[31] = {
	.class_hid = BNXT_ULP_CLASS_HID_0439,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[32] = {
	.class_hid = BNXT_ULP_CLASS_HID_34e1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[33] = {
	.class_hid = BNXT_ULP_CLASS_HID_0465,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[34] = {
	.class_hid = BNXT_ULP_CLASS_HID_352d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20488,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[35] = {
	.class_hid = BNXT_ULP_CLASS_HID_55b1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[36] = {
	.class_hid = BNXT_ULP_CLASS_HID_1da5,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22536,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[37] = {
	.class_hid = BNXT_ULP_CLASS_HID_32fd,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[38] = {
	.class_hid = BNXT_ULP_CLASS_HID_63a5,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28680,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[39] = {
	.class_hid = BNXT_ULP_CLASS_HID_1b75,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[40] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c3d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30728,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[41] = {
	.class_hid = BNXT_ULP_CLASS_HID_1031,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[42] = {
	.class_hid = BNXT_ULP_CLASS_HID_40c9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16392,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[43] = {
	.class_hid = BNXT_ULP_CLASS_HID_3eb9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[44] = {
	.class_hid = BNXT_ULP_CLASS_HID_068d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24584,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[45] = {
	.class_hid = BNXT_ULP_CLASS_HID_5039,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[46] = {
	.class_hid = BNXT_ULP_CLASS_HID_180d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49160,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[47] = {
	.class_hid = BNXT_ULP_CLASS_HID_15fd,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[48] = {
	.class_hid = BNXT_ULP_CLASS_HID_46b5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57352,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[49] = {
	.class_hid = BNXT_ULP_CLASS_HID_303d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[50] = {
	.class_hid = BNXT_ULP_CLASS_HID_60f5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81928,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[51] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ea5,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[52] = {
	.class_hid = BNXT_ULP_CLASS_HID_2689,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90120,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[53] = {
	.class_hid = BNXT_ULP_CLASS_HID_0771,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[54] = {
	.class_hid = BNXT_ULP_CLASS_HID_3809,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114696,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[55] = {
	.class_hid = BNXT_ULP_CLASS_HID_35f9,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[56] = {
	.class_hid = BNXT_ULP_CLASS_HID_66b1,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122888,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[57] = {
	.class_hid = BNXT_ULP_CLASS_HID_559d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[58] = {
	.class_hid = BNXT_ULP_CLASS_HID_1db1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[59] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e15,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[60] = {
	.class_hid = BNXT_ULP_CLASS_HID_0609,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[61] = {
	.class_hid = BNXT_ULP_CLASS_HID_1bc1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[62] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c09,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12296,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[63] = {
	.class_hid = BNXT_ULP_CLASS_HID_0459,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[64] = {
	.class_hid = BNXT_ULP_CLASS_HID_3481,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[65] = {
	.class_hid = BNXT_ULP_CLASS_HID_0405,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[66] = {
	.class_hid = BNXT_ULP_CLASS_HID_354d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20488,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[67] = {
	.class_hid = BNXT_ULP_CLASS_HID_55d1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[68] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dc5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22536,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[69] = {
	.class_hid = BNXT_ULP_CLASS_HID_329d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[70] = {
	.class_hid = BNXT_ULP_CLASS_HID_63c5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28680,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[71] = {
	.class_hid = BNXT_ULP_CLASS_HID_1b15,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[72] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c5d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30728,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[73] = {
	.class_hid = BNXT_ULP_CLASS_HID_1051,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[74] = {
	.class_hid = BNXT_ULP_CLASS_HID_40a9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16392,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[75] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ed9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[76] = {
	.class_hid = BNXT_ULP_CLASS_HID_06ed,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24584,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[77] = {
	.class_hid = BNXT_ULP_CLASS_HID_5059,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[78] = {
	.class_hid = BNXT_ULP_CLASS_HID_186d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49160,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[79] = {
	.class_hid = BNXT_ULP_CLASS_HID_159d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[80] = {
	.class_hid = BNXT_ULP_CLASS_HID_46d5,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57352,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[81] = {
	.class_hid = BNXT_ULP_CLASS_HID_305d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[82] = {
	.class_hid = BNXT_ULP_CLASS_HID_6095,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81928,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[83] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ec5,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[84] = {
	.class_hid = BNXT_ULP_CLASS_HID_26e9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90120,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[85] = {
	.class_hid = BNXT_ULP_CLASS_HID_0711,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[86] = {
	.class_hid = BNXT_ULP_CLASS_HID_3869,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114696,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[87] = {
	.class_hid = BNXT_ULP_CLASS_HID_3599,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[88] = {
	.class_hid = BNXT_ULP_CLASS_HID_66d1,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122888,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[89] = {
	.class_hid = BNXT_ULP_CLASS_HID_38e7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[90] = {
	.class_hid = BNXT_ULP_CLASS_HID_00db,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32776,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[91] = {
	.class_hid = BNXT_ULP_CLASS_HID_24f3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[92] = {
	.class_hid = BNXT_ULP_CLASS_HID_55bb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[93] = {
	.class_hid = BNXT_ULP_CLASS_HID_5023,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[94] = {
	.class_hid = BNXT_ULP_CLASS_HID_1817,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49160,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[95] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bcf,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[96] = {
	.class_hid = BNXT_ULP_CLASS_HID_0423,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[97] = {
	.class_hid = BNXT_ULP_CLASS_HID_58e3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[98] = {
	.class_hid = BNXT_ULP_CLASS_HID_20d7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98312,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[99] = {
	.class_hid = BNXT_ULP_CLASS_HID_448f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[100] = {
	.class_hid = BNXT_ULP_CLASS_HID_0ce3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[101] = {
	.class_hid = BNXT_ULP_CLASS_HID_076b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[102] = {
	.class_hid = BNXT_ULP_CLASS_HID_3813,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114696,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[103] = {
	.class_hid = BNXT_ULP_CLASS_HID_5bcb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[104] = {
	.class_hid = BNXT_ULP_CLASS_HID_243f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[105] = {
	.class_hid = BNXT_ULP_CLASS_HID_144b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[106] = {
	.class_hid = BNXT_ULP_CLASS_HID_4573,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163848,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[107] = {
	.class_hid = BNXT_ULP_CLASS_HID_0057,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[108] = {
	.class_hid = BNXT_ULP_CLASS_HID_311f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163912,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[109] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b87,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[110] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c4f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180232,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[111] = {
	.class_hid = BNXT_ULP_CLASS_HID_1793,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[112] = {
	.class_hid = BNXT_ULP_CLASS_HID_485b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180296,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[113] = {
	.class_hid = BNXT_ULP_CLASS_HID_3447,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[114] = {
	.class_hid = BNXT_ULP_CLASS_HID_650f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[115] = {
	.class_hid = BNXT_ULP_CLASS_HID_2053,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[116] = {
	.class_hid = BNXT_ULP_CLASS_HID_511b,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229448,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[117] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b83,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[118] = {
	.class_hid = BNXT_ULP_CLASS_HID_13f7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[119] = {
	.class_hid = BNXT_ULP_CLASS_HID_37af,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[120] = {
	.class_hid = BNXT_ULP_CLASS_HID_6857,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[121] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d1f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[122] = {
	.class_hid = BNXT_ULP_CLASS_HID_0563,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131080,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[123] = {
	.class_hid = BNXT_ULP_CLASS_HID_290b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[124] = {
	.class_hid = BNXT_ULP_CLASS_HID_59c3,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[125] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d1b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[126] = {
	.class_hid = BNXT_ULP_CLASS_HID_256f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196616,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[127] = {
	.class_hid = BNXT_ULP_CLASS_HID_4937,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[128] = {
	.class_hid = BNXT_ULP_CLASS_HID_111b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196680,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[129] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f4b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[130] = {
	.class_hid = BNXT_ULP_CLASS_HID_275f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[131] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b67,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[132] = {
	.class_hid = BNXT_ULP_CLASS_HID_134b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[133] = {
	.class_hid = BNXT_ULP_CLASS_HID_1683,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[134] = {
	.class_hid = BNXT_ULP_CLASS_HID_475b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[135] = {
	.class_hid = BNXT_ULP_CLASS_HID_02bf,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[136] = {
	.class_hid = BNXT_ULP_CLASS_HID_3377,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[137] = {
	.class_hid = BNXT_ULP_CLASS_HID_19db,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[138] = {
	.class_hid = BNXT_ULP_CLASS_HID_4a93,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[139] = {
	.class_hid = BNXT_ULP_CLASS_HID_05f7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[140] = {
	.class_hid = BNXT_ULP_CLASS_HID_368f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655432,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[141] = {
	.class_hid = BNXT_ULP_CLASS_HID_39c7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[142] = {
	.class_hid = BNXT_ULP_CLASS_HID_022b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[143] = {
	.class_hid = BNXT_ULP_CLASS_HID_25f3,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[144] = {
	.class_hid = BNXT_ULP_CLASS_HID_568b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720968,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[145] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c37,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[146] = {
	.class_hid = BNXT_ULP_CLASS_HID_041b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917512,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[147] = {
	.class_hid = BNXT_ULP_CLASS_HID_2823,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[148] = {
	.class_hid = BNXT_ULP_CLASS_HID_58fb,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[149] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c33,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[150] = {
	.class_hid = BNXT_ULP_CLASS_HID_2407,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983048,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[151] = {
	.class_hid = BNXT_ULP_CLASS_HID_482f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[152] = {
	.class_hid = BNXT_ULP_CLASS_HID_1033,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[153] = {
	.class_hid = BNXT_ULP_CLASS_HID_3887,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[154] = {
	.class_hid = BNXT_ULP_CLASS_HID_00bb,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32776,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[155] = {
	.class_hid = BNXT_ULP_CLASS_HID_2493,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[156] = {
	.class_hid = BNXT_ULP_CLASS_HID_55db,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[157] = {
	.class_hid = BNXT_ULP_CLASS_HID_5043,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[158] = {
	.class_hid = BNXT_ULP_CLASS_HID_1877,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49160,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[159] = {
	.class_hid = BNXT_ULP_CLASS_HID_3baf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[160] = {
	.class_hid = BNXT_ULP_CLASS_HID_0443,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[161] = {
	.class_hid = BNXT_ULP_CLASS_HID_5883,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[162] = {
	.class_hid = BNXT_ULP_CLASS_HID_20b7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98312,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[163] = {
	.class_hid = BNXT_ULP_CLASS_HID_44ef,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[164] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c83,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[165] = {
	.class_hid = BNXT_ULP_CLASS_HID_070b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[166] = {
	.class_hid = BNXT_ULP_CLASS_HID_3873,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114696,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[167] = {
	.class_hid = BNXT_ULP_CLASS_HID_5bab,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[168] = {
	.class_hid = BNXT_ULP_CLASS_HID_245f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[169] = {
	.class_hid = BNXT_ULP_CLASS_HID_142b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[170] = {
	.class_hid = BNXT_ULP_CLASS_HID_4513,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163848,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[171] = {
	.class_hid = BNXT_ULP_CLASS_HID_0037,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[172] = {
	.class_hid = BNXT_ULP_CLASS_HID_317f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163912,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[173] = {
	.class_hid = BNXT_ULP_CLASS_HID_2be7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[174] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c2f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180232,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[175] = {
	.class_hid = BNXT_ULP_CLASS_HID_17f3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[176] = {
	.class_hid = BNXT_ULP_CLASS_HID_483b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180296,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[177] = {
	.class_hid = BNXT_ULP_CLASS_HID_3427,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[178] = {
	.class_hid = BNXT_ULP_CLASS_HID_656f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[179] = {
	.class_hid = BNXT_ULP_CLASS_HID_2033,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[180] = {
	.class_hid = BNXT_ULP_CLASS_HID_517b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229448,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[181] = {
	.class_hid = BNXT_ULP_CLASS_HID_4be3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[182] = {
	.class_hid = BNXT_ULP_CLASS_HID_1397,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[183] = {
	.class_hid = BNXT_ULP_CLASS_HID_37cf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[184] = {
	.class_hid = BNXT_ULP_CLASS_HID_6837,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[185] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d7f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[186] = {
	.class_hid = BNXT_ULP_CLASS_HID_0503,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131080,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[187] = {
	.class_hid = BNXT_ULP_CLASS_HID_296b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[188] = {
	.class_hid = BNXT_ULP_CLASS_HID_59a3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[189] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d7b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[190] = {
	.class_hid = BNXT_ULP_CLASS_HID_250f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196616,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[191] = {
	.class_hid = BNXT_ULP_CLASS_HID_4957,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[192] = {
	.class_hid = BNXT_ULP_CLASS_HID_117b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196680,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[193] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f2b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[194] = {
	.class_hid = BNXT_ULP_CLASS_HID_273f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[195] = {
	.class_hid = BNXT_ULP_CLASS_HID_4b07,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[196] = {
	.class_hid = BNXT_ULP_CLASS_HID_132b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[197] = {
	.class_hid = BNXT_ULP_CLASS_HID_16e3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[198] = {
	.class_hid = BNXT_ULP_CLASS_HID_473b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[199] = {
	.class_hid = BNXT_ULP_CLASS_HID_02df,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[200] = {
	.class_hid = BNXT_ULP_CLASS_HID_3317,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[201] = {
	.class_hid = BNXT_ULP_CLASS_HID_19bb,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[202] = {
	.class_hid = BNXT_ULP_CLASS_HID_4af3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[203] = {
	.class_hid = BNXT_ULP_CLASS_HID_0597,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[204] = {
	.class_hid = BNXT_ULP_CLASS_HID_36ef,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655432,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[205] = {
	.class_hid = BNXT_ULP_CLASS_HID_39a7,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[206] = {
	.class_hid = BNXT_ULP_CLASS_HID_024b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[207] = {
	.class_hid = BNXT_ULP_CLASS_HID_2593,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[208] = {
	.class_hid = BNXT_ULP_CLASS_HID_56eb,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720968,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[209] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c57,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[210] = {
	.class_hid = BNXT_ULP_CLASS_HID_047b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917512,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[211] = {
	.class_hid = BNXT_ULP_CLASS_HID_2843,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[212] = {
	.class_hid = BNXT_ULP_CLASS_HID_589b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[213] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c53,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[214] = {
	.class_hid = BNXT_ULP_CLASS_HID_2467,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983048,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[215] = {
	.class_hid = BNXT_ULP_CLASS_HID_484f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[216] = {
	.class_hid = BNXT_ULP_CLASS_HID_1053,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[217] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ce1,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[218] = {
	.class_hid = BNXT_ULP_CLASS_HID_4579,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[219] = {
	.class_hid = BNXT_ULP_CLASS_HID_1735,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[220] = {
	.class_hid = BNXT_ULP_CLASS_HID_45bd,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[221] = {
	.class_hid = BNXT_ULP_CLASS_HID_3feb,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[222] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bf7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[223] = {
	.class_hid = BNXT_ULP_CLASS_HID_5727,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[224] = {
	.class_hid = BNXT_ULP_CLASS_HID_4333,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[225] = {
	.class_hid = BNXT_ULP_CLASS_HID_4453,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[226] = {
	.class_hid = BNXT_ULP_CLASS_HID_304f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[227] = {
	.class_hid = BNXT_ULP_CLASS_HID_645f,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[228] = {
	.class_hid = BNXT_ULP_CLASS_HID_504b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[229] = {
	.class_hid = BNXT_ULP_CLASS_HID_5cc1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[230] = {
	.class_hid = BNXT_ULP_CLASS_HID_4559,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[231] = {
	.class_hid = BNXT_ULP_CLASS_HID_2285,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[232] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b1d,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT }
	},
	[233] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b49,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[234] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c95,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[235] = {
	.class_hid = BNXT_ULP_CLASS_HID_39c1,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[236] = {
	.class_hid = BNXT_ULP_CLASS_HID_2259,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_4_BITMASK_O_TCP_DST_PORT }
	},
	[237] = {
	.class_hid = BNXT_ULP_CLASS_HID_1715,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[238] = {
	.class_hid = BNXT_ULP_CLASS_HID_459d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[239] = {
	.class_hid = BNXT_ULP_CLASS_HID_571d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[240] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cd1,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT }
	},
	[241] = {
	.class_hid = BNXT_ULP_CLASS_HID_3711,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[242] = {
	.class_hid = BNXT_ULP_CLASS_HID_6599,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[243] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e55,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[244] = {
	.class_hid = BNXT_ULP_CLASS_HID_3cdd,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_5_BITMASK_O_TCP_DST_PORT }
	},
	[245] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ca1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[246] = {
	.class_hid = BNXT_ULP_CLASS_HID_4539,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[247] = {
	.class_hid = BNXT_ULP_CLASS_HID_22e5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[248] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b7d,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT }
	},
	[249] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b29,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[250] = {
	.class_hid = BNXT_ULP_CLASS_HID_5cf5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[251] = {
	.class_hid = BNXT_ULP_CLASS_HID_39a1,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[252] = {
	.class_hid = BNXT_ULP_CLASS_HID_2239,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_6_BITMASK_O_UDP_DST_PORT }
	},
	[253] = {
	.class_hid = BNXT_ULP_CLASS_HID_1775,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[254] = {
	.class_hid = BNXT_ULP_CLASS_HID_45fd,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[255] = {
	.class_hid = BNXT_ULP_CLASS_HID_577d,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[256] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cb1,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT }
	},
	[257] = {
	.class_hid = BNXT_ULP_CLASS_HID_3771,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[258] = {
	.class_hid = BNXT_ULP_CLASS_HID_65f9,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[259] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e35,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[260] = {
	.class_hid = BNXT_ULP_CLASS_HID_3cbd,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_7_BITMASK_O_UDP_DST_PORT }
	},
	[261] = {
	.class_hid = BNXT_ULP_CLASS_HID_3fcb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[262] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bd7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[263] = {
	.class_hid = BNXT_ULP_CLASS_HID_5707,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[264] = {
	.class_hid = BNXT_ULP_CLASS_HID_4313,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[265] = {
	.class_hid = BNXT_ULP_CLASS_HID_5fc7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[266] = {
	.class_hid = BNXT_ULP_CLASS_HID_4bd3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[267] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e4f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[268] = {
	.class_hid = BNXT_ULP_CLASS_HID_632f,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT }
	},
	[269] = {
	.class_hid = BNXT_ULP_CLASS_HID_1baf,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[270] = {
	.class_hid = BNXT_ULP_CLASS_HID_07bb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[271] = {
	.class_hid = BNXT_ULP_CLASS_HID_32eb,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[272] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ef7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[273] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bab,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[274] = {
	.class_hid = BNXT_ULP_CLASS_HID_27b7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[275] = {
	.class_hid = BNXT_ULP_CLASS_HID_52e7,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[276] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ef3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_8_BITMASK_O_TCP_DST_PORT }
	},
	[277] = {
	.class_hid = BNXT_ULP_CLASS_HID_4473,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[278] = {
	.class_hid = BNXT_ULP_CLASS_HID_306f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[279] = {
	.class_hid = BNXT_ULP_CLASS_HID_647f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[280] = {
	.class_hid = BNXT_ULP_CLASS_HID_506b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[281] = {
	.class_hid = BNXT_ULP_CLASS_HID_66af,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[282] = {
	.class_hid = BNXT_ULP_CLASS_HID_525b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[283] = {
	.class_hid = BNXT_ULP_CLASS_HID_1de7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[284] = {
	.class_hid = BNXT_ULP_CLASS_HID_0993,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT }
	},
	[285] = {
	.class_hid = BNXT_ULP_CLASS_HID_213f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[286] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d2b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[287] = {
	.class_hid = BNXT_ULP_CLASS_HID_413b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[288] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cd7,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[289] = {
	.class_hid = BNXT_ULP_CLASS_HID_436b,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[290] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f07,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[291] = {
	.class_hid = BNXT_ULP_CLASS_HID_6317,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[292] = {
	.class_hid = BNXT_ULP_CLASS_HID_4f03,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_1_9_BITMASK_O_TCP_DST_PORT }
	},
	[293] = {
	.class_hid = BNXT_ULP_CLASS_HID_3fab,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[294] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bb7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[295] = {
	.class_hid = BNXT_ULP_CLASS_HID_5767,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[296] = {
	.class_hid = BNXT_ULP_CLASS_HID_4373,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[297] = {
	.class_hid = BNXT_ULP_CLASS_HID_5fa7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[298] = {
	.class_hid = BNXT_ULP_CLASS_HID_4bb3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[299] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e2f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[300] = {
	.class_hid = BNXT_ULP_CLASS_HID_634f,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT }
	},
	[301] = {
	.class_hid = BNXT_ULP_CLASS_HID_1bcf,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[302] = {
	.class_hid = BNXT_ULP_CLASS_HID_07db,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[303] = {
	.class_hid = BNXT_ULP_CLASS_HID_328b,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[304] = {
	.class_hid = BNXT_ULP_CLASS_HID_1e97,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[305] = {
	.class_hid = BNXT_ULP_CLASS_HID_3bcb,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[306] = {
	.class_hid = BNXT_ULP_CLASS_HID_27d7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[307] = {
	.class_hid = BNXT_ULP_CLASS_HID_5287,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[308] = {
	.class_hid = BNXT_ULP_CLASS_HID_3e93,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_10_BITMASK_O_UDP_DST_PORT }
	},
	[309] = {
	.class_hid = BNXT_ULP_CLASS_HID_4413,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[310] = {
	.class_hid = BNXT_ULP_CLASS_HID_300f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[311] = {
	.class_hid = BNXT_ULP_CLASS_HID_641f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[312] = {
	.class_hid = BNXT_ULP_CLASS_HID_500b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[313] = {
	.class_hid = BNXT_ULP_CLASS_HID_66cf,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[314] = {
	.class_hid = BNXT_ULP_CLASS_HID_523b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[315] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d87,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[316] = {
	.class_hid = BNXT_ULP_CLASS_HID_09f3,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT }
	},
	[317] = {
	.class_hid = BNXT_ULP_CLASS_HID_215f,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[318] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d4b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[319] = {
	.class_hid = BNXT_ULP_CLASS_HID_415b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[320] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cb7,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[321] = {
	.class_hid = BNXT_ULP_CLASS_HID_430b,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[322] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f67,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[323] = {
	.class_hid = BNXT_ULP_CLASS_HID_6377,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[324] = {
	.class_hid = BNXT_ULP_CLASS_HID_4f63,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_1_11_BITMASK_O_UDP_DST_PORT }
	},
	[325] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b5,
	.class_tid = 1,
	.hdr_sig_id = 0,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_0_BITMASK_O_ETH_SMAC }
	},
	[326] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ad,
	.class_tid = 1,
	.hdr_sig_id = 1,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_1_BITMASK_O_ETH_SMAC }
	},
	[327] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b7,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC }
	},
	[328] = {
	.class_hid = BNXT_ULP_CLASS_HID_1583,
	.class_tid = 1,
	.hdr_sig_id = 2,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_2_BITMASK_OO_VLAN_VID }
	},
	[329] = {
	.class_hid = BNXT_ULP_CLASS_HID_29af,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC }
	},
	[330] = {
	.class_hid = BNXT_ULP_CLASS_HID_159b,
	.class_tid = 1,
	.hdr_sig_id = 3,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_3_BITMASK_OO_VLAN_VID }
	},
	[331] = {
	.class_hid = BNXT_ULP_CLASS_HID_2995,
	.class_tid = 1,
	.hdr_sig_id = 4,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_4_BITMASK_O_ETH_SMAC }
	},
	[332] = {
	.class_hid = BNXT_ULP_CLASS_HID_298d,
	.class_tid = 1,
	.hdr_sig_id = 5,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_5_BITMASK_O_ETH_SMAC }
	},
	[333] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f5,
	.class_tid = 1,
	.hdr_sig_id = 6,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_6_BITMASK_O_ETH_SMAC }
	},
	[334] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ed,
	.class_tid = 1,
	.hdr_sig_id = 7,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_7_BITMASK_O_ETH_SMAC }
	},
	[335] = {
	.class_hid = BNXT_ULP_CLASS_HID_2997,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC }
	},
	[336] = {
	.class_hid = BNXT_ULP_CLASS_HID_15a3,
	.class_tid = 1,
	.hdr_sig_id = 8,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_8_BITMASK_OO_VLAN_VID }
	},
	[337] = {
	.class_hid = BNXT_ULP_CLASS_HID_298f,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC }
	},
	[338] = {
	.class_hid = BNXT_ULP_CLASS_HID_15bb,
	.class_tid = 1,
	.hdr_sig_id = 9,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_9_BITMASK_OO_VLAN_VID }
	},
	[339] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f7,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC }
	},
	[340] = {
	.class_hid = BNXT_ULP_CLASS_HID_15c3,
	.class_tid = 1,
	.hdr_sig_id = 10,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_10_BITMASK_OO_VLAN_VID }
	},
	[341] = {
	.class_hid = BNXT_ULP_CLASS_HID_29ef,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 8,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC }
	},
	[342] = {
	.class_hid = BNXT_ULP_CLASS_HID_15db,
	.class_tid = 1,
	.hdr_sig_id = 11,
	.flow_sig_id = 72,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_1_11_BITMASK_OO_VLAN_VID }
	},
	[343] = {
	.class_hid = BNXT_ULP_CLASS_HID_1151,
	.class_tid = 1,
	.hdr_sig_id = 12,
	.flow_sig_id = 16384,
	.flow_pattern_id = 3,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_12_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_12_BITMASK_O_IPV4_DST_ADDR }
	},
	[344] = {
	.class_hid = BNXT_ULP_CLASS_HID_315d,
	.class_tid = 1,
	.hdr_sig_id = 12,
	.flow_sig_id = 81920,
	.flow_pattern_id = 3,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_HDR_BIT_T_VXLAN |
		BNXT_ULP_FLOW_DIR_BITMASK_ING },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_1_12_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_1_12_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_1_12_BITMASK_O_UDP_DST_PORT }
	},
	[345] = {
	.class_hid = BNXT_ULP_CLASS_HID_34c6,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[346] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c22,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 4100,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[347] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cbe,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[348] = {
	.class_hid = BNXT_ULP_CLASS_HID_179a,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 6148,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[349] = {
	.class_hid = BNXT_ULP_CLASS_HID_59be,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[350] = {
	.class_hid = BNXT_ULP_CLASS_HID_515a,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 16388,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[351] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c72,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[352] = {
	.class_hid = BNXT_ULP_CLASS_HID_171e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 24580,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[353] = {
	.class_hid = BNXT_ULP_CLASS_HID_19c8,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[354] = {
	.class_hid = BNXT_ULP_CLASS_HID_112c,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32772,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[355] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d68,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[356] = {
	.class_hid = BNXT_ULP_CLASS_HID_444c,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32836,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[357] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e8c,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[358] = {
	.class_hid = BNXT_ULP_CLASS_HID_09e0,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49156,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[359] = {
	.class_hid = BNXT_ULP_CLASS_HID_1af0,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[360] = {
	.class_hid = BNXT_ULP_CLASS_HID_15d4,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49220,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[361] = {
	.class_hid = BNXT_ULP_CLASS_HID_1dd0,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[362] = {
	.class_hid = BNXT_ULP_CLASS_HID_14f4,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131076,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[363] = {
	.class_hid = BNXT_ULP_CLASS_HID_70b0,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[364] = {
	.class_hid = BNXT_ULP_CLASS_HID_4854,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131140,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[365] = {
	.class_hid = BNXT_ULP_CLASS_HID_3dd4,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[366] = {
	.class_hid = BNXT_ULP_CLASS_HID_34f8,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196612,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[367] = {
	.class_hid = BNXT_ULP_CLASS_HID_09e8,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[368] = {
	.class_hid = BNXT_ULP_CLASS_HID_008c,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196676,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[369] = {
	.class_hid = BNXT_ULP_CLASS_HID_34e6,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[370] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c02,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4100,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[371] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c9e,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[372] = {
	.class_hid = BNXT_ULP_CLASS_HID_17ba,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6148,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[373] = {
	.class_hid = BNXT_ULP_CLASS_HID_429e,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[374] = {
	.class_hid = BNXT_ULP_CLASS_HID_5dba,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12292,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[375] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a16,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[376] = {
	.class_hid = BNXT_ULP_CLASS_HID_2532,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 14340,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[377] = {
	.class_hid = BNXT_ULP_CLASS_HID_2da2,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[378] = {
	.class_hid = BNXT_ULP_CLASS_HID_24fe,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 20484,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[379] = {
	.class_hid = BNXT_ULP_CLASS_HID_355a,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[380] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c76,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 22532,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[381] = {
	.class_hid = BNXT_ULP_CLASS_HID_13e6,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[382] = {
	.class_hid = BNXT_ULP_CLASS_HID_7276,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 28676,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[383] = {
	.class_hid = BNXT_ULP_CLASS_HID_42d2,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[384] = {
	.class_hid = BNXT_ULP_CLASS_HID_5dee,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30724,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[385] = {
	.class_hid = BNXT_ULP_CLASS_HID_59de,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[386] = {
	.class_hid = BNXT_ULP_CLASS_HID_513a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 16388,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[387] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c12,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[388] = {
	.class_hid = BNXT_ULP_CLASS_HID_177e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 24580,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[389] = {
	.class_hid = BNXT_ULP_CLASS_HID_0e92,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[390] = {
	.class_hid = BNXT_ULP_CLASS_HID_09fe,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 49156,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[391] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c1a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[392] = {
	.class_hid = BNXT_ULP_CLASS_HID_5746,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 57348,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[393] = {
	.class_hid = BNXT_ULP_CLASS_HID_79da,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[394] = {
	.class_hid = BNXT_ULP_CLASS_HID_7106,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 81924,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[395] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c1e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[396] = {
	.class_hid = BNXT_ULP_CLASS_HID_377a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 90116,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[397] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e9e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[398] = {
	.class_hid = BNXT_ULP_CLASS_HID_29fa,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 114692,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[399] = {
	.class_hid = BNXT_ULP_CLASS_HID_14d2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[400] = {
	.class_hid = BNXT_ULP_CLASS_HID_7742,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 122884,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[401] = {
	.class_hid = BNXT_ULP_CLASS_HID_3706,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[402] = {
	.class_hid = BNXT_ULP_CLASS_HID_0fe2,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4100,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[403] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f7e,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[404] = {
	.class_hid = BNXT_ULP_CLASS_HID_145a,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6148,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[405] = {
	.class_hid = BNXT_ULP_CLASS_HID_417e,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[406] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e5a,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12292,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[407] = {
	.class_hid = BNXT_ULP_CLASS_HID_29f6,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[408] = {
	.class_hid = BNXT_ULP_CLASS_HID_26d2,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 14340,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[409] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e42,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[410] = {
	.class_hid = BNXT_ULP_CLASS_HID_271e,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 20484,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[411] = {
	.class_hid = BNXT_ULP_CLASS_HID_36ba,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[412] = {
	.class_hid = BNXT_ULP_CLASS_HID_0f96,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 22532,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[413] = {
	.class_hid = BNXT_ULP_CLASS_HID_1006,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[414] = {
	.class_hid = BNXT_ULP_CLASS_HID_7196,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 28676,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[415] = {
	.class_hid = BNXT_ULP_CLASS_HID_4132,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[416] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e0e,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30724,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[417] = {
	.class_hid = BNXT_ULP_CLASS_HID_59fe,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[418] = {
	.class_hid = BNXT_ULP_CLASS_HID_511a,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 16388,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[419] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c32,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[420] = {
	.class_hid = BNXT_ULP_CLASS_HID_175e,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 24580,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[421] = {
	.class_hid = BNXT_ULP_CLASS_HID_0eb2,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[422] = {
	.class_hid = BNXT_ULP_CLASS_HID_09de,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 49156,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[423] = {
	.class_hid = BNXT_ULP_CLASS_HID_5c3a,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[424] = {
	.class_hid = BNXT_ULP_CLASS_HID_5766,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 57348,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[425] = {
	.class_hid = BNXT_ULP_CLASS_HID_79fa,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[426] = {
	.class_hid = BNXT_ULP_CLASS_HID_7126,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 81924,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[427] = {
	.class_hid = BNXT_ULP_CLASS_HID_3c3e,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[428] = {
	.class_hid = BNXT_ULP_CLASS_HID_375a,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 90116,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[429] = {
	.class_hid = BNXT_ULP_CLASS_HID_2ebe,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[430] = {
	.class_hid = BNXT_ULP_CLASS_HID_29da,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 114692,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[431] = {
	.class_hid = BNXT_ULP_CLASS_HID_14f2,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[432] = {
	.class_hid = BNXT_ULP_CLASS_HID_7762,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 122884,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[433] = {
	.class_hid = BNXT_ULP_CLASS_HID_19e8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[434] = {
	.class_hid = BNXT_ULP_CLASS_HID_110c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32772,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[435] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d48,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[436] = {
	.class_hid = BNXT_ULP_CLASS_HID_446c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32836,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[437] = {
	.class_hid = BNXT_ULP_CLASS_HID_0eac,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[438] = {
	.class_hid = BNXT_ULP_CLASS_HID_09c0,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49156,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[439] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ad0,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[440] = {
	.class_hid = BNXT_ULP_CLASS_HID_15f4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49220,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[441] = {
	.class_hid = BNXT_ULP_CLASS_HID_39ec,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[442] = {
	.class_hid = BNXT_ULP_CLASS_HID_3100,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98308,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[443] = {
	.class_hid = BNXT_ULP_CLASS_HID_0210,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[444] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d34,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98372,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[445] = {
	.class_hid = BNXT_ULP_CLASS_HID_2ea0,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[446] = {
	.class_hid = BNXT_ULP_CLASS_HID_29c4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114692,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[447] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ad4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[448] = {
	.class_hid = BNXT_ULP_CLASS_HID_35e8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114756,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[449] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d80,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[450] = {
	.class_hid = BNXT_ULP_CLASS_HID_54a4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163844,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[451] = {
	.class_hid = BNXT_ULP_CLASS_HID_29b4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[452] = {
	.class_hid = BNXT_ULP_CLASS_HID_20c8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163908,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[453] = {
	.class_hid = BNXT_ULP_CLASS_HID_7244,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[454] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d98,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180228,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[455] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e68,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[456] = {
	.class_hid = BNXT_ULP_CLASS_HID_598c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180292,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[457] = {
	.class_hid = BNXT_ULP_CLASS_HID_1248,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[458] = {
	.class_hid = BNXT_ULP_CLASS_HID_74d8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229380,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[459] = {
	.class_hid = BNXT_ULP_CLASS_HID_49a8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[460] = {
	.class_hid = BNXT_ULP_CLASS_HID_40cc,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229444,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[461] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b0c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[462] = {
	.class_hid = BNXT_ULP_CLASS_HID_0220,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245764,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[463] = {
	.class_hid = BNXT_ULP_CLASS_HID_1730,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[464] = {
	.class_hid = BNXT_ULP_CLASS_HID_7980,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245828,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[465] = {
	.class_hid = BNXT_ULP_CLASS_HID_1db0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[466] = {
	.class_hid = BNXT_ULP_CLASS_HID_1494,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131076,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[467] = {
	.class_hid = BNXT_ULP_CLASS_HID_70d0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[468] = {
	.class_hid = BNXT_ULP_CLASS_HID_4834,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131140,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[469] = {
	.class_hid = BNXT_ULP_CLASS_HID_3db4,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[470] = {
	.class_hid = BNXT_ULP_CLASS_HID_3498,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196612,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[471] = {
	.class_hid = BNXT_ULP_CLASS_HID_0988,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[472] = {
	.class_hid = BNXT_ULP_CLASS_HID_00ec,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196676,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[473] = {
	.class_hid = BNXT_ULP_CLASS_HID_3f44,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[474] = {
	.class_hid = BNXT_ULP_CLASS_HID_36a8,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393220,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[475] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b58,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[476] = {
	.class_hid = BNXT_ULP_CLASS_HID_02bc,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393284,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[477] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f48,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[478] = {
	.class_hid = BNXT_ULP_CLASS_HID_56ac,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458756,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[479] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b5c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[480] = {
	.class_hid = BNXT_ULP_CLASS_HID_2280,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458820,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[481] = {
	.class_hid = BNXT_ULP_CLASS_HID_4000,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[482] = {
	.class_hid = BNXT_ULP_CLASS_HID_5b64,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655364,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[483] = {
	.class_hid = BNXT_ULP_CLASS_HID_2c14,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[484] = {
	.class_hid = BNXT_ULP_CLASS_HID_2778,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655428,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[485] = {
	.class_hid = BNXT_ULP_CLASS_HID_18f8,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[486] = {
	.class_hid = BNXT_ULP_CLASS_HID_13dc,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720900,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[487] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c18,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[488] = {
	.class_hid = BNXT_ULP_CLASS_HID_477c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720964,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[489] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a88,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[490] = {
	.class_hid = BNXT_ULP_CLASS_HID_15ec,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917508,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[491] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e28,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[492] = {
	.class_hid = BNXT_ULP_CLASS_HID_490c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917572,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[493] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a8c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[494] = {
	.class_hid = BNXT_ULP_CLASS_HID_35f0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983044,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[495] = {
	.class_hid = BNXT_ULP_CLASS_HID_06e0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[496] = {
	.class_hid = BNXT_ULP_CLASS_HID_01c4,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983108,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[497] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a08,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[498] = {
	.class_hid = BNXT_ULP_CLASS_HID_12ec,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32772,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[499] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ea8,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[500] = {
	.class_hid = BNXT_ULP_CLASS_HID_478c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32836,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[501] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d4c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[502] = {
	.class_hid = BNXT_ULP_CLASS_HID_0a20,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49156,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[503] = {
	.class_hid = BNXT_ULP_CLASS_HID_1930,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[504] = {
	.class_hid = BNXT_ULP_CLASS_HID_1614,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49220,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[505] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a0c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[506] = {
	.class_hid = BNXT_ULP_CLASS_HID_32e0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98308,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[507] = {
	.class_hid = BNXT_ULP_CLASS_HID_01f0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[508] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ed4,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98372,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[509] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d40,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[510] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a24,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114692,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[511] = {
	.class_hid = BNXT_ULP_CLASS_HID_3934,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[512] = {
	.class_hid = BNXT_ULP_CLASS_HID_3608,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114756,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[513] = {
	.class_hid = BNXT_ULP_CLASS_HID_5e60,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[514] = {
	.class_hid = BNXT_ULP_CLASS_HID_5744,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163844,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[515] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a54,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[516] = {
	.class_hid = BNXT_ULP_CLASS_HID_2328,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163908,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[517] = {
	.class_hid = BNXT_ULP_CLASS_HID_71a4,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[518] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e78,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180228,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[519] = {
	.class_hid = BNXT_ULP_CLASS_HID_5d88,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[520] = {
	.class_hid = BNXT_ULP_CLASS_HID_5a6c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180292,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[521] = {
	.class_hid = BNXT_ULP_CLASS_HID_11a8,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[522] = {
	.class_hid = BNXT_ULP_CLASS_HID_7738,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229380,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[523] = {
	.class_hid = BNXT_ULP_CLASS_HID_4a48,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[524] = {
	.class_hid = BNXT_ULP_CLASS_HID_432c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229444,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[525] = {
	.class_hid = BNXT_ULP_CLASS_HID_08ec,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[526] = {
	.class_hid = BNXT_ULP_CLASS_HID_01c0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245764,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[527] = {
	.class_hid = BNXT_ULP_CLASS_HID_14d0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[528] = {
	.class_hid = BNXT_ULP_CLASS_HID_7a60,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245828,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[529] = {
	.class_hid = BNXT_ULP_CLASS_HID_1d90,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[530] = {
	.class_hid = BNXT_ULP_CLASS_HID_14b4,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131076,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[531] = {
	.class_hid = BNXT_ULP_CLASS_HID_70f0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[532] = {
	.class_hid = BNXT_ULP_CLASS_HID_4814,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131140,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[533] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d94,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[534] = {
	.class_hid = BNXT_ULP_CLASS_HID_34b8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196612,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[535] = {
	.class_hid = BNXT_ULP_CLASS_HID_09a8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[536] = {
	.class_hid = BNXT_ULP_CLASS_HID_00cc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196676,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[537] = {
	.class_hid = BNXT_ULP_CLASS_HID_3f64,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[538] = {
	.class_hid = BNXT_ULP_CLASS_HID_3688,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393220,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[539] = {
	.class_hid = BNXT_ULP_CLASS_HID_0b78,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[540] = {
	.class_hid = BNXT_ULP_CLASS_HID_029c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393284,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[541] = {
	.class_hid = BNXT_ULP_CLASS_HID_5f68,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[542] = {
	.class_hid = BNXT_ULP_CLASS_HID_568c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458756,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[543] = {
	.class_hid = BNXT_ULP_CLASS_HID_2b7c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[544] = {
	.class_hid = BNXT_ULP_CLASS_HID_22a0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458820,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[545] = {
	.class_hid = BNXT_ULP_CLASS_HID_4020,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[546] = {
	.class_hid = BNXT_ULP_CLASS_HID_5b44,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655364,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[547] = {
	.class_hid = BNXT_ULP_CLASS_HID_2c34,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[548] = {
	.class_hid = BNXT_ULP_CLASS_HID_2758,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655428,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[549] = {
	.class_hid = BNXT_ULP_CLASS_HID_18d8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[550] = {
	.class_hid = BNXT_ULP_CLASS_HID_13fc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720900,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[551] = {
	.class_hid = BNXT_ULP_CLASS_HID_4c38,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[552] = {
	.class_hid = BNXT_ULP_CLASS_HID_475c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720964,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[553] = {
	.class_hid = BNXT_ULP_CLASS_HID_1aa8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[554] = {
	.class_hid = BNXT_ULP_CLASS_HID_15cc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917508,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[555] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e08,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[556] = {
	.class_hid = BNXT_ULP_CLASS_HID_492c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917572,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[557] = {
	.class_hid = BNXT_ULP_CLASS_HID_3aac,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[558] = {
	.class_hid = BNXT_ULP_CLASS_HID_35d0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983044,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[559] = {
	.class_hid = BNXT_ULP_CLASS_HID_06c0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[560] = {
	.class_hid = BNXT_ULP_CLASS_HID_01e4,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983108,
	.flow_pattern_id = 0,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[561] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d32,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[562] = {
	.class_hid = BNXT_ULP_CLASS_HID_54aa,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_0_BITMASK_O_IPV6_DST_ADDR }
	},
	[563] = {
	.class_hid = BNXT_ULP_CLASS_HID_0686,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[564] = {
	.class_hid = BNXT_ULP_CLASS_HID_540e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_1_BITMASK_O_IPV4_DST_ADDR }
	},
	[565] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e3c,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[566] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a20,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[567] = {
	.class_hid = BNXT_ULP_CLASS_HID_46f0,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[568] = {
	.class_hid = BNXT_ULP_CLASS_HID_52e4,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_2_BITMASK_O_IPV6_DST_ADDR }
	},
	[569] = {
	.class_hid = BNXT_ULP_CLASS_HID_55e4,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[570] = {
	.class_hid = BNXT_ULP_CLASS_HID_21f8,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[571] = {
	.class_hid = BNXT_ULP_CLASS_HID_75e8,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[572] = {
	.class_hid = BNXT_ULP_CLASS_HID_41fc,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_3_BITMASK_O_IPV4_DST_ADDR }
	},
	[573] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d12,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[574] = {
	.class_hid = BNXT_ULP_CLASS_HID_548a,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR }
	},
	[575] = {
	.class_hid = BNXT_ULP_CLASS_HID_3356,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 12288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[576] = {
	.class_hid = BNXT_ULP_CLASS_HID_1ace,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 14336,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT }
	},
	[577] = {
	.class_hid = BNXT_ULP_CLASS_HID_1a9a,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 20480,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[578] = {
	.class_hid = BNXT_ULP_CLASS_HID_4d46,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 22528,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[579] = {
	.class_hid = BNXT_ULP_CLASS_HID_2812,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 28672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[580] = {
	.class_hid = BNXT_ULP_CLASS_HID_338a,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 30720,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_4_BITMASK_O_TCP_DST_PORT }
	},
	[581] = {
	.class_hid = BNXT_ULP_CLASS_HID_06e6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[582] = {
	.class_hid = BNXT_ULP_CLASS_HID_546e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR }
	},
	[583] = {
	.class_hid = BNXT_ULP_CLASS_HID_46ee,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[584] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d22,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 57344,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT }
	},
	[585] = {
	.class_hid = BNXT_ULP_CLASS_HID_26e2,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 81920,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[586] = {
	.class_hid = BNXT_ULP_CLASS_HID_746a,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 90112,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[587] = {
	.class_hid = BNXT_ULP_CLASS_HID_1fa6,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[588] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d2e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 122880,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_5_BITMASK_O_TCP_DST_PORT }
	},
	[589] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ef2,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4096,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[590] = {
	.class_hid = BNXT_ULP_CLASS_HID_576a,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 6144,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR }
	},
	[591] = {
	.class_hid = BNXT_ULP_CLASS_HID_30b6,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 12288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[592] = {
	.class_hid = BNXT_ULP_CLASS_HID_192e,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 14336,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT }
	},
	[593] = {
	.class_hid = BNXT_ULP_CLASS_HID_197a,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 20480,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[594] = {
	.class_hid = BNXT_ULP_CLASS_HID_4ea6,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 22528,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[595] = {
	.class_hid = BNXT_ULP_CLASS_HID_2bf2,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 28672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[596] = {
	.class_hid = BNXT_ULP_CLASS_HID_306a,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 30720,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_6_BITMASK_O_UDP_DST_PORT }
	},
	[597] = {
	.class_hid = BNXT_ULP_CLASS_HID_06c6,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 16384,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[598] = {
	.class_hid = BNXT_ULP_CLASS_HID_544e,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 24576,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR }
	},
	[599] = {
	.class_hid = BNXT_ULP_CLASS_HID_46ce,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[600] = {
	.class_hid = BNXT_ULP_CLASS_HID_0d02,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 57344,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT }
	},
	[601] = {
	.class_hid = BNXT_ULP_CLASS_HID_26c2,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 81920,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[602] = {
	.class_hid = BNXT_ULP_CLASS_HID_744a,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 90112,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[603] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f86,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[604] = {
	.class_hid = BNXT_ULP_CLASS_HID_2d0e,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 122880,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_7_BITMASK_O_UDP_DST_PORT }
	},
	[605] = {
	.class_hid = BNXT_ULP_CLASS_HID_2e1c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[606] = {
	.class_hid = BNXT_ULP_CLASS_HID_3a00,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[607] = {
	.class_hid = BNXT_ULP_CLASS_HID_46d0,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[608] = {
	.class_hid = BNXT_ULP_CLASS_HID_52c4,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR }
	},
	[609] = {
	.class_hid = BNXT_ULP_CLASS_HID_4e10,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98304,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[610] = {
	.class_hid = BNXT_ULP_CLASS_HID_5a04,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 98368,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[611] = {
	.class_hid = BNXT_ULP_CLASS_HID_1f98,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[612] = {
	.class_hid = BNXT_ULP_CLASS_HID_72f8,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 114752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT }
	},
	[613] = {
	.class_hid = BNXT_ULP_CLASS_HID_0a78,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163840,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[614] = {
	.class_hid = BNXT_ULP_CLASS_HID_166c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 163904,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[615] = {
	.class_hid = BNXT_ULP_CLASS_HID_233c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180224,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[616] = {
	.class_hid = BNXT_ULP_CLASS_HID_0f20,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 180288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[617] = {
	.class_hid = BNXT_ULP_CLASS_HID_2a7c,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229376,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[618] = {
	.class_hid = BNXT_ULP_CLASS_HID_3660,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 229440,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[619] = {
	.class_hid = BNXT_ULP_CLASS_HID_4330,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245760,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[620] = {
	.class_hid = BNXT_ULP_CLASS_HID_2f24,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 245824,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_8_BITMASK_O_TCP_DST_PORT }
	},
	[621] = {
	.class_hid = BNXT_ULP_CLASS_HID_5584,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[622] = {
	.class_hid = BNXT_ULP_CLASS_HID_2198,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[623] = {
	.class_hid = BNXT_ULP_CLASS_HID_7588,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[624] = {
	.class_hid = BNXT_ULP_CLASS_HID_419c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR }
	},
	[625] = {
	.class_hid = BNXT_ULP_CLASS_HID_7758,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[626] = {
	.class_hid = BNXT_ULP_CLASS_HID_43ac,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 393280,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[627] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c10,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[628] = {
	.class_hid = BNXT_ULP_CLASS_HID_1864,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 458816,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT }
	},
	[629] = {
	.class_hid = BNXT_ULP_CLASS_HID_30c8,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655360,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[630] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cdc,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 655424,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[631] = {
	.class_hid = BNXT_ULP_CLASS_HID_50cc,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720896,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[632] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d20,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 720960,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[633] = {
	.class_hid = BNXT_ULP_CLASS_HID_529c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917504,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[634] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ef0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 917568,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[635] = {
	.class_hid = BNXT_ULP_CLASS_HID_72e0,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983040,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[636] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ef4,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 983104,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_SRC_PORT |
		BNXT_ULP_HF_0_2_9_BITMASK_O_TCP_DST_PORT }
	},
	[637] = {
	.class_hid = BNXT_ULP_CLASS_HID_2dfc,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32768,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[638] = {
	.class_hid = BNXT_ULP_CLASS_HID_39e0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 32832,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[639] = {
	.class_hid = BNXT_ULP_CLASS_HID_4530,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49152,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[640] = {
	.class_hid = BNXT_ULP_CLASS_HID_5124,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 49216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR }
	},
	[641] = {
	.class_hid = BNXT_ULP_CLASS_HID_4df0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98304,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[642] = {
	.class_hid = BNXT_ULP_CLASS_HID_59e4,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 98368,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[643] = {
	.class_hid = BNXT_ULP_CLASS_HID_1c78,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114688,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[644] = {
	.class_hid = BNXT_ULP_CLASS_HID_7118,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 114752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT }
	},
	[645] = {
	.class_hid = BNXT_ULP_CLASS_HID_0998,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163840,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[646] = {
	.class_hid = BNXT_ULP_CLASS_HID_158c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 163904,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[647] = {
	.class_hid = BNXT_ULP_CLASS_HID_20dc,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180224,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[648] = {
	.class_hid = BNXT_ULP_CLASS_HID_0cc0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 180288,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[649] = {
	.class_hid = BNXT_ULP_CLASS_HID_299c,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229376,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[650] = {
	.class_hid = BNXT_ULP_CLASS_HID_3580,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 229440,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[651] = {
	.class_hid = BNXT_ULP_CLASS_HID_40d0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245760,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[652] = {
	.class_hid = BNXT_ULP_CLASS_HID_2cc4,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 245824,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_SRC_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_IPV6_DST_ADDR |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_10_BITMASK_O_UDP_DST_PORT }
	},
	[653] = {
	.class_hid = BNXT_ULP_CLASS_HID_55a4,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131072,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[654] = {
	.class_hid = BNXT_ULP_CLASS_HID_21b8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 131136,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[655] = {
	.class_hid = BNXT_ULP_CLASS_HID_75a8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196608,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[656] = {
	.class_hid = BNXT_ULP_CLASS_HID_41bc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 196672,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR }
	},
	[657] = {
	.class_hid = BNXT_ULP_CLASS_HID_7778,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393216,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[658] = {
	.class_hid = BNXT_ULP_CLASS_HID_438c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 393280,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[659] = {
	.class_hid = BNXT_ULP_CLASS_HID_0c30,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458752,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[660] = {
	.class_hid = BNXT_ULP_CLASS_HID_1844,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 458816,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT }
	},
	[661] = {
	.class_hid = BNXT_ULP_CLASS_HID_30e8,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655360,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[662] = {
	.class_hid = BNXT_ULP_CLASS_HID_1cfc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 655424,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[663] = {
	.class_hid = BNXT_ULP_CLASS_HID_50ec,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720896,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[664] = {
	.class_hid = BNXT_ULP_CLASS_HID_3d00,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 720960,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[665] = {
	.class_hid = BNXT_ULP_CLASS_HID_52bc,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917504,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[666] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ed0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 917568,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[667] = {
	.class_hid = BNXT_ULP_CLASS_HID_72c0,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983040,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[668] = {
	.class_hid = BNXT_ULP_CLASS_HID_5ed4,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 983104,
	.flow_pattern_id = 1,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_SRC_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_IPV4_DST_ADDR |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_SRC_PORT |
		BNXT_ULP_HF_0_2_11_BITMASK_O_UDP_DST_PORT }
	},
	[669] = {
	.class_hid = BNXT_ULP_CLASS_HID_3866,
	.class_tid = 2,
	.hdr_sig_id = 0,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_0_BITMASK_O_ETH_SMAC }
	},
	[670] = {
	.class_hid = BNXT_ULP_CLASS_HID_381e,
	.class_tid = 2,
	.hdr_sig_id = 1,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_1_BITMASK_O_ETH_SMAC }
	},
	[671] = {
	.class_hid = BNXT_ULP_CLASS_HID_3860,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC }
	},
	[672] = {
	.class_hid = BNXT_ULP_CLASS_HID_0454,
	.class_tid = 2,
	.hdr_sig_id = 2,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_2_BITMASK_OO_VLAN_VID }
	},
	[673] = {
	.class_hid = BNXT_ULP_CLASS_HID_3818,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC }
	},
	[674] = {
	.class_hid = BNXT_ULP_CLASS_HID_042c,
	.class_tid = 2,
	.hdr_sig_id = 3,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_3_BITMASK_OO_VLAN_VID }
	},
	[675] = {
	.class_hid = BNXT_ULP_CLASS_HID_3846,
	.class_tid = 2,
	.hdr_sig_id = 4,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_4_BITMASK_O_ETH_SMAC }
	},
	[676] = {
	.class_hid = BNXT_ULP_CLASS_HID_387e,
	.class_tid = 2,
	.hdr_sig_id = 5,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_5_BITMASK_O_ETH_SMAC }
	},
	[677] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ba6,
	.class_tid = 2,
	.hdr_sig_id = 6,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_6_BITMASK_O_ETH_SMAC }
	},
	[678] = {
	.class_hid = BNXT_ULP_CLASS_HID_385e,
	.class_tid = 2,
	.hdr_sig_id = 7,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_7_BITMASK_O_ETH_SMAC }
	},
	[679] = {
	.class_hid = BNXT_ULP_CLASS_HID_3840,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC }
	},
	[680] = {
	.class_hid = BNXT_ULP_CLASS_HID_0474,
	.class_tid = 2,
	.hdr_sig_id = 8,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_8_BITMASK_OO_VLAN_VID }
	},
	[681] = {
	.class_hid = BNXT_ULP_CLASS_HID_3878,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC }
	},
	[682] = {
	.class_hid = BNXT_ULP_CLASS_HID_044c,
	.class_tid = 2,
	.hdr_sig_id = 9,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_TCP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_9_BITMASK_OO_VLAN_VID }
	},
	[683] = {
	.class_hid = BNXT_ULP_CLASS_HID_3ba0,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC }
	},
	[684] = {
	.class_hid = BNXT_ULP_CLASS_HID_0794,
	.class_tid = 2,
	.hdr_sig_id = 10,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV6 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_10_BITMASK_OO_VLAN_VID }
	},
	[685] = {
	.class_hid = BNXT_ULP_CLASS_HID_3858,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 4,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC }
	},
	[686] = {
	.class_hid = BNXT_ULP_CLASS_HID_046c,
	.class_tid = 2,
	.hdr_sig_id = 11,
	.flow_sig_id = 68,
	.flow_pattern_id = 2,
	.app_sig = 0,
	.hdr_sig = { .bits =
		BNXT_ULP_HDR_BIT_O_ETH |
		BNXT_ULP_HDR_BIT_OO_VLAN |
		BNXT_ULP_HDR_BIT_O_IPV4 |
		BNXT_ULP_HDR_BIT_O_UDP |
		BNXT_ULP_FLOW_DIR_BITMASK_EGR },
	.field_sig = { .bits =
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_DMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_O_ETH_SMAC |
		BNXT_ULP_HF_0_2_11_BITMASK_OO_VLAN_VID }
	}
};
